#!/usr/bin/env python

# plane_3d Rel 3
# Created by Tin Tran
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Higher height.
# ...
# Rel 4: Changed so it would for for me on GIMP 2.10 and static view but looks good.
#import math
#import string
#import Image
from gimpfu import *
#from array import array

def python_plane_3d(image, layer, texturelayer):
	heightrange = 20
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()

	if not layer.has_alpha:
		pdb.gimp_layer_add_alpha(layer)

	if not texturelayer.has_alpha:
		pdb.gimp_layer_add_alpha(texturelayer)

	new_image = pdb.gimp_image_new(layer.width,layer.height,RGB)
	pdb.gimp_display_new(new_image)
	new_layer = pdb.gimp_layer_new(new_image,new_image.width,new_image.height,RGBA_IMAGE,"plane 3d",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	
	#width = float(layer.width-1)/gridx
	#height = float(layer.height-1)/gridy
	width = layer.width
	height = layer.height
	for y in range(0,height):
		for x in range(0,width):
			num_channels,pixel = pdb.gimp_drawable_get_pixel(layer,x,y)
			color_value = int((pixel[0]+pixel[1]+pixel[2])/3.0)
			num_channels,colorpixel = pdb.gimp_drawable_get_pixel(texturelayer,x,y)
			z = 1.0 + float(abs(height-y))/height
			dx = x-(width/2.0)
			dy1 = height/2.0 #bottom of screen
			dy2 = dy1 - (float(color_value)/255.0 * heightrange)
			px = dx/z + width/2.0
			py1 = dy1/z + height/2.0
			py2 = dy2/z + height/2.0
			for i in range(int(py2),max(int(py2+1),int(py1+1))):
				pdb.gimp_drawable_set_pixel(new_layer,px,i,num_channels,colorpixel)
		pdb.gimp_drawable_update(new_layer,0,0,new_layer.width,new_layer.height)
		pdb.gimp_displays_flush()
		pdb.gimp_progress_update(float(y)/height)
	pdb.gimp_selection_none(image)
	pdb.gimp_selection_none(new_image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	
    #return

register(
	"python_fu_plane_3d",                           
	"Creates a 3d plain",
	"Creates a 3d plain",
	"Tin Tran",
	"Tin Tran",
	"Dec 2019",
	"<Image>/Python-Fu/Plane 3d...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_DRAWABLE, "texturelayer", "Texture Layer:", None),
	#(PF_COLOR, "oldcolor",  "Replace Color:",  (43,198,255)),
	#(PF_COLOR, "newcolor",  "With New Color:",  (255,198,0)),
	#(PF_SPINNER, "x1", "x1:", 0, (0, 100, 0.5)),
	#(PF_SPINNER, "y1", "y1:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "x2", "x2:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "y2", "y2:", 0, (0, 100, 0.5)),
	#(PF_COLOR, "black",  "Black point color",  (0,0,0) PF_FILE, "infilename", "Temp Filepath", "/Default/Path"),
	#(PF_COLOR, "white",  "White point color",  (255,255,255) ),
	#(PF_COLOR, "gray",  "Gray point color",  (128,128,128) )
	#(PF_FILE, "infilename", "Temp Filepath", "/Default/Path")
	#(PF_DIRNAME, "source_directory", "Source Directory", "") for some reason, on my computer when i(Tin) use PF_DIRNAME the pythonw.exe would crash
	],
	[],
	python_plane_3d)

main()
