#!/usr/bin/env python

# Add_Guides_In_Range Rel 1
# Created by Tin Tran
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.

import math
import string
#import Image
from gimpfu import *
from array import array
def python_add_guides_in_range(image, layer,orientation,range_start,range_end,sections) :
	pdb.gimp_image_undo_group_start(image)
	
	width = pdb.gimp_image_width(image)
	height = pdb.gimp_image_height(image)
	
	if orientation == 1: #vertical guides
		span = width
	else:                #horizontal guides
		span = height
		
	start = range_start/100.0 * span
	end = range_end/100.0 * span
		
	span_width = end - start #calculate the span width we're dealing with
	for i in range(0,int(sections+1)):
		guide_position = start + i * (span_width/sections)
		pdb.script_fu_guide_new(image,layer,orientation,guide_position)
	
	
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_add_guides_in_range",
	"Add Multiple Guides in Range",
	"Add Multiple Guides in Range...",
	"Tin Tran",
	"Tin Tran",
	"2014",
	"<Image>/Image/Guides/Add Multiple Guides in Range",
	"*",      # Create a new image, don't work on an existing one
	[
	(PF_OPTION, "orientation",   "Orientation:", 0, ["Horizontal","Vertical"]),
	(PF_SPINNER, "range_start", "Range Start Percentage:", 0, (0, 100, 0.5)),
	(PF_SPINNER, "range_end", "Range End Percentage:", 100, (0, 100, 0.5)),
	(PF_SPINNER, "sections", "Number of Sections:", 5, (1, 100, 1)),
	],
	[],
	python_add_guides_in_range)

main()
