#!/usr/bin/env python

# abs_1.py
# abstract experiment 1.
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
def ell_rad(area): #ellipse radius given area
	radius = (area/math.pi)**0.5 #returns radius
	return radius

def python_abs_1(image, layer) :
	pdb.gimp_image_undo_group_start(image)
	colors = 5; #number of colors to do
	incy = 10;
	pdb.gimp_context_push()
	if (not layer.has_alpha):
		pdb.gimp_layer_add_alpha(layer)
	largeside = max(layer.width,layer.height)
	pdb.gimp_image_scale_full(image,largeside,largeside,INTERPOLATION_CUBIC)
	#pdb.gimp_layer_scale_full(layer,largeside,largeside,TRUE,INTERPOLATION_CUBIC)
	work_layers = []
	for layer in image.layers: #only work on visible layers
		if layer.visible:
			work_layers.append(layer)
	for layer in work_layers: #hide all layers
		layer.visible = False

	work_layers.reverse() #reverse working order so that the generated order is the same.
	new_visibles = []
	removelayers = []
	for layer in work_layers:
		layer.visible = True #open one by one
		pdb.gimp_displays_flush()	
		new_layer = pdb.gimp_layer_new_from_visible(image,image,"visible")
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		new_layer.visible = False
		new_visibles.append(new_layer)
		removelayers.append(layer)

	for removelayer in removelayers: #reomve layers as we're done with them
			pdb.gimp_image_remove_layer(image,removelayer)

	for layer in new_visibles:
		layer.visible = True
		removelayers = []
		pdb.gimp_layer_resize_to_image_size(layer)
		new_layer = pdb.gimp_layer_new_from_drawable(layer,image)
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		pdb.gimp_layer_set_opacity(new_layer,50)
		pdb.gimp_item_transform_flip_simple(new_layer,ORIENTATION_HORIZONTAL,TRUE,largeside/2.0)
		removelayers.append(new_layer)
		new_layer = pdb.gimp_layer_new_from_visible(image,image,"visible 2")
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		pdb.gimp_layer_set_opacity(new_layer,50)
		pdb.gimp_item_transform_flip_simple(new_layer,ORIENTATION_VERTICAL,TRUE,largeside/2.0)
		removelayers.append(new_layer)
		new_layer = pdb.gimp_layer_new_from_visible(image,image,"visible 3")
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		pdb.gimp_layer_set_opacity(new_layer,50)
		pdb.gimp_item_transform_rotate_simple(new_layer,ROTATE_90,TRUE,0,0)
		removelayers.append(new_layer)
		#pdb.gimp_item_transform_flip_simple(new_layer,ORIENTATION_VERTICAL,TRUE,largeside/2.0)
		new_layer = pdb.gimp_layer_new_from_visible(image,image,"visible all")
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		removelayers.append(layer)
		new_layer.visible = False
		pdb.gimp_brightness_contrast(new_layer,0,52)
		for removelayer in removelayers:
			pdb.gimp_image_remove_layer(image,removelayer)




	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_abs_1_tt",
	"Abstract 1",
	"Abstract 1",
	"Tin Tran",
	"Tin Tran",
	"November 2019",
	"<Image>/Python-Fu/Abtract 1",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_abs_1)

main()
