#!/usr/bin/env python

# abs-10.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: If texture layer doesn't have alpha we add it.
#import Image
from gimpfu import *
import random
import math
import os
class myobj:
	subboxes = 0;
def python_abs10_tt(image,layer,match,mergedown,levels,searches) :
	pdb.gimp_image_undo_group_start(image)
	if not match.has_alpha:
		pdb.gimp_layer_add_alpha(match)
	#imagesize = 10000
	#new_image = pdb.gimp_image_new(imagesize,imagesize,RGB)
	#new_display = pdb.gimp_display_new(new_image)
	#new_image = image
	new_image = image
	#new_layer = pdb.gimp_layer_new(new_image,imagesize,imagesize,RGBA_IMAGE,"tree",100,LAYER_MODE_NORMAL)
	#pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	
	#tree #branches = [[imagesize/2,imagesize,startwidth,startlength,startangle,1]]
	#root = myobj();
	levels = int(levels);
	pdb.gimp_selection_all(image)
	branches = [[]];
	for l in range(0,levels):
		#now subtract all boxes if there are any
		nextbranches = [];
		for i in range(0,len(branches)):
			b = branches[i] #current branch
			#pdb.gimp_message(b);
			pdb.gimp_selection_all(image)
			for z in range(0,len(b)):
				pdb.gimp_image_select_polygon(image,CHANNEL_OP_SUBTRACT,8,b[z]) #subtract boxes
			non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
			selwidth = x2-x1
			selheight = y2-y1
			if selwidth >= selheight: #wider than height
				midx1 = x1 + selwidth/2.0 + random.randrange(int(selwidth/5.0))-selwidth/10.0
				midx2 = x1 + selwidth/2.0 + random.randrange(int(selwidth/5.0))-selwidth/10.0
				subbox1 = [midx1,y1, x2,y1, x2,y2, midx2,y2]
				subbox2 = [x1,y1, midx1,y1, midx2,y2, x1,y2]
			else:
				midy1 = y1 + selheight/2.0 + random.randrange(int(selheight/5.0))-selheight/10.0
				midy2 = y1 + selheight/2.0 + random.randrange(int(selheight/5.0))-selheight/10.0
				subbox1 = [x1,y1, x2,y1, x2,midy2, x1,midy1]
				subbox2 = [x1,midy1, x2,midy2, x2,y2, x1,y2]
			child1 = list(b)
			child2 = list(b)
			child1.append(subbox1)
			child2.append(subbox2)
			#pdb.gimp_message("childs");
			#pdb.gimp_message(child1);
			#pdb.gimp_message(child2);
			nextbranches.append(child1)
			nextbranches.append(child2)
		    
		branches = nextbranches #set for next time through loop
	#do operations here	
	searches_to_do = int(searches)
	for i in range(0,len(branches)):
		b = branches[i] #current branch
		pdb.gimp_selection_all(image)
		for z in range(0,len(b)):
			pdb.gimp_image_select_polygon(image,CHANNEL_OP_SUBTRACT,8,b[z]) #subtract boxes
		#here we have selection to work with
		#copy match layer
		texture_layer = pdb.gimp_layer_new_from_drawable(match,image)
		pdb.gimp_image_insert_layer(image,texture_layer,None,0)
		pdb.gimp_layer_set_mode(texture_layer,LAYER_MODE_DIFFERENCE)
		#get bounds and width/height of selection
		non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
		if non_empty:
			selection = pdb.gimp_selection_save(image) #save channel
			selwidth = x2-x1
			selheight = y2-y1
			best_average = 256 * 3;
			best_x = 0;
			best_y = 0;
			for s in range(0,searches_to_do):
				x = random.randrange(texture_layer.width-selwidth) - (texture_layer.width-x2)
				y = random.randrange(texture_layer.height-selheight) - (texture_layer.height-y2)
				pdb.gimp_layer_set_offsets(texture_layer,x,y)
				#create visible layer
				#visible = pdb.gimp_layer_new_from_visible(image,image,"visible")
				#pdb.gimp_image_insert_layer(image,visible,None,0)
				
				#do all this to save memory on creating a whole layer see if it's faster
				pdb.gimp_edit_copy_visible(image)
				visible = pdb.gimp_edit_paste(texture_layer,TRUE)
				pdb.gimp_floating_sel_to_layer(visible)
				pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,selection) #reselect after making visible portion
				
				R,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(visible,HISTOGRAM_RED,0,255)
				G,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(visible,HISTOGRAM_GREEN,0,255)
				B,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(visible,HISTOGRAM_BLUE,0,255)
				#pdb.gimp_message(str(R2+G2+B2) + ":" + str(R+G+B))
				average = R+G+B
				if (average < best_average): #found a better match
					best_x = x;
					best_y = y;
					best_average = average
				#remove visible after check
				#pdb.gimp_item_delete(visible)
				pdb.gimp_image_remove_layer(image,visible)
				#pdb.gimp_image_remove_layer(image,visible)
			pdb.gimp_image_remove_channel(image,selection)
			#here we should have best match offsets.
			#offset it invert selection delete
			pdb.gimp_layer_set_offsets(texture_layer,best_x,best_y)
			pdb.gimp_layer_set_mode(texture_layer,LAYER_MODE_NORMAL)
			pdb.gimp_selection_invert(image)
			pdb.gimp_drawable_edit_clear(texture_layer)
			if mergedown == 1:
				layer = pdb.gimp_image_merge_down(image,texture_layer,CLIP_TO_BOTTOM_LAYER)
			pdb.gimp_displays_flush()




	
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_abs10_tt",
	"Abstract 10 random tile match",
	"Abstract 10 random tile match",
	"Tin Tran",
	"Tin Tran",
	"Jan 2020",
	"<Image>/Python-Fu/Abstract 10 Tile Match...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	(PF_DRAWABLE, "match", "Texture layer to use:", None),
	(PF_TOGGLE, "mergedown",   "Merge Down layers:", 1),
	(PF_SPINNER, "levels", "Levels to subdivide (into powers of 2 pieces):", 5, (1, 20, 1)),
	(PF_SPINNER, "searches", "Random Searches per tile (how many times to shift image to search):", 30, (10, 500, 1)),
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_abs10_tt)

main()
