#!/usr/bin/env python

# abs-6.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
import os
def python_abs6_tt(image,layer) :
	pdb.gimp_image_undo_group_start(image)
	num_bytes,colormap = pdb.gimp_image_get_colormap(image)
	colors = int(num_bytes/3)

	#creates a new image of same size and create a display for it.
	new_image = pdb.gimp_image_new(layer.width,layer.height,RGB)
	new_display = pdb.gimp_display_new(new_image)
	new_layer = pdb.gimp_layer_new(new_image,layer.width,layer.height,RGBA_IMAGE,"abs 2",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	x1 = 0
	x2 = layer.width
	y1 = 0
	y2 = layer.height
	total = layer.width * layer.height
	pdb.gimp_context_set_sample_threshold(0)
	pdb.gimp_context_set_sample_threshold_int(0)
	colorsv = []
	for i in range(0,colors):
		start = i * 3
		color = (colormap[start],colormap[start+1],colormap[start+2])
		#pdb.gimp_image_select_color(image,CHANNEL_OP_REPLACE,layer,color)
		#mean,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(layer,HISTOGRAM_VALUE,0,255)
		colorsv.append(color)
	#colorsv.sort(key=lambda x:random.randrange(colors))
	rot = 20
	for i in range(0,len(colorsv)): #loop through each color and do work
		color = colorsv[i]
		pdb.gimp_image_select_color(image,CHANNEL_OP_REPLACE,layer,color)
		mean,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(layer,HISTOGRAM_VALUE,0,255)
		#count now point to pixel count
		type = i % 4 #based on type we use different rules for drawing
		pdb.gimp_context_set_foreground(color)
		if True: #pixels < ((x2-x1) * (y2-y1)): #only do it if it fits
			new_layer = pdb.gimp_layer_new(new_image,layer.width,layer.height,RGBA_IMAGE,"abs 2",100,LAYER_MODE_NORMAL)
			pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
			'''if type == 0: #draw on the left
				height = y2-y1
				width = pixels/height
				pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x1,y1,max(1,width),max(1,height))
				pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)
				pdb.gimp_item_transform_rotate(new_layer,(random.randrange(rot)-rot/2)/360.0*2*math.pi,FALSE,x1+width/2,y1+height/2)
				x1 += width
			elif type == 1: #draw on top
				width = x2-x1
				height = pixels/width
				pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x1,y1,max(1,width),max(1,height))
				pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)
				pdb.gimp_item_transform_rotate(new_layer,(random.randrange(rot)-rot/2)/360.0*2*math.pi,FALSE,x1+width/2,y1+height/2)
				y1 += height
			elif type == 2: #draw on right
				height = y2 - y1
				width = pixels/height
				pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x2-width,y1,max(1,width),max(1,height))
				pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)
				pdb.gimp_item_transform_rotate(new_layer,(random.randrange(rot)-rot/2)/360.0*2*math.pi,FALSE,x2-width+width/2,y1+height/2)
				x2 -= width
			elif type == 3: #draw on bottom
				width = x2-x1
				height = pixels/width
				pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x1,y2-height,max(1,width),max(1,height))
				pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)
				pdb.gimp_item_transform_rotate(new_layer,(random.randrange(rot)-rot/2)/360.0*2*math.pi,FALSE,x1+width/2,y2-height+height/2)
				y2 -= height
			'''
			tree_square = (pixels/2.0)/8.0
			tree_side = tree_square ** 0.5
			x = random.randrange(int(x2-x1)) + x1
			y = ((y2-y1)/2.0)/colors * i + ((y2-y1)/2.0)
			radius = ((pixels)/math.pi)**0.5
			radius2 = ((pixels/2.0)/math.pi)**0.5

			pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x-tree_side/2.0,y-tree_side*8.0,tree_side,tree_side*8.0)
			pdb.gimp_image_select_ellipse(new_image,CHANNEL_OP_ADD,x-radius,y-tree_side*7.8-radius*2.0,radius*2.0,radius*2.0)
			pdb.gimp_image_select_ellipse(new_image,CHANNEL_OP_SUBTRACT,x-radius2,y-tree_side*7.8-radius-radius2,radius2*2.0,radius2*2.0)
			non_empty,_x1,_y1,_x2,_y2 = pdb.gimp_selection_bounds(image)
			if non_empty:
				pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)


			pdb.gimp_image_merge_down(new_image,new_layer,CLIP_TO_BOTTOM_LAYER)
		pdb.gimp_displays_flush()
		
	pdb.gimp_message("Total:" + str(total))	
	#pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_abs6_tt",
	"Abstract 6 Trees",
	"Abstract 6 Trees",
	"Tin Tran",
	"Tin Tran",
	"December 2019",
	"<Image>/Python-Fu/Abstract 6 Trees...",             #Menu path
	"INDEXED*", 
	[
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_abs6_tt)

main()
