#!/usr/bin/env python

# abs-7.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
import os
def python_abs7_tt(image,layer,shape,mergedown) :
	pdb.gimp_image_undo_group_start(image)
	num_bytes,colormap = pdb.gimp_image_get_colormap(image)
	colors = int(num_bytes/3)

	#creates a new image of same size and create a display for it.
	new_image = pdb.gimp_image_new(layer.width,layer.height,RGB)
	new_display = pdb.gimp_display_new(new_image)
	new_layer = pdb.gimp_layer_new(new_image,layer.width,layer.height,RGBA_IMAGE,"abs 2",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	x1 = 0
	x2 = layer.width
	y1 = 0
	y2 = layer.height
	total = layer.width * layer.height
	pdb.gimp_context_set_sample_threshold(0)
	pdb.gimp_context_set_sample_threshold_int(0)
	colorsv = []
	for i in range(0,colors):
		start = i * 3
		color = (colormap[start],colormap[start+1],colormap[start+2])
		#pdb.gimp_image_select_color(image,CHANNEL_OP_REPLACE,layer,color)
		#mean,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(layer,HISTOGRAM_VALUE,0,255)
		colorsv.append(color)
	#colorsv.sort(key=lambda x:random.randrange(colors))
	rot = 20
	for i in range(0,len(colorsv)): #loop through each color and do work
		color = colorsv[i]
		pdb.gimp_image_select_color(image,CHANNEL_OP_REPLACE,layer,color)
		mean,std_dev,median,pixels,count,percentile = pdb.gimp_histogram(layer,HISTOGRAM_VALUE,0,255)
		#count now point to pixel count
		type = i % 4 #based on type we use different rules for drawing
		pdb.gimp_context_set_foreground(color)
		if True: #pixels < ((x2-x1) * (y2-y1)): #only do it if it fits
			#new_layer = pdb.gimp_layer_new(new_image,layer.width,layer.height,RGBA_IMAGE,"abs 2",100,LAYER_MODE_NORMAL)
			new_layer = pdb.gimp_layer_new_from_drawable(shape,new_image)
			pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
			pdb.plug_in_autocrop_layer(new_image,new_layer) #autocrop layer
			width = (pixels)**0.5 #just use square root to get width treat it like a square as we don't know the shape.
			heightscale = float(new_layer.height)/new_layer.width #save heightscale
			new_width = width
			new_height = width * heightscale
			#scale and offset it randomly
			pdb.gimp_layer_scale(new_layer,new_width,new_height,FALSE)
			pdb.gimp_layer_set_offsets(new_layer,random.randrange(max(1,int(image.width-new_width))),random.randrange(max(1,int(image.height-new_height))))
			#fill it with solid color
			pdb.gimp_layer_set_lock_alpha(new_layer,TRUE) #lock alpha
			pdb.gimp_edit_fill(new_layer,FILL_FOREGROUND)
			pdb.gimp_layer_set_lock_alpha(new_layer,FALSE) #unlock alpha

			if mergedown == 1: #if mergedown then merge down else user probbaly wants to manipulate layers themselves
				pdb.gimp_image_merge_down(new_image,new_layer,CLIP_TO_BOTTOM_LAYER)
		pdb.gimp_displays_flush()
		
	#pdb.gimp_message("Total:" + str(total))	
	#pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_abs7_tt",
	"Abstract 7 Trees",
	"Abstract 7 Trees",
	"Tin Tran",
	"Tin Tran",
	"December 2019",
	"<Image>/Python-Fu/Abstract 7 Custom shapes...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	(PF_DRAWABLE, "shape", "Shape layer (with Alpha):", None),
	(PF_TOGGLE, "mergedown",   "Merge Down layers:", 1),
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_abs7_tt)

main()
