#!/usr/bin/env python

# alpha-to-snowflake.py
# Created by Tin Tran http://gimplearn.net
# Comments directed to http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import string
import random
#import Image
from gimpfu import *
from array import array
import sys


def python_alpha_to_snowflake(image, layer, points):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	points = int(points)
	#create a layer to work with
	flake_layer = pdb.gimp_layer_new(image,layer.width,layer.height,RGBA_IMAGE,"Snowflake Layer",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image,flake_layer,None,0)
	#create points number of layers
	each_angle = 360.0/points
	for i in range(0,points):
		layer_copy = pdb.gimp_layer_new_from_drawable(layer,image)
		pdb.gimp_image_insert_layer(image,layer_copy,None,0)
		item = pdb.gimp_item_transform_rotate(layer_copy,math.radians(i*each_angle),TRUE,0,0)
		flake_layer = pdb.gimp_image_merge_down(image,layer_copy,EXPAND_AS_NECESSARY)

	#created flipped version
	layer_copy = pdb.gimp_layer_new_from_drawable(flake_layer,image)
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	item = pdb.gimp_item_transform_flip_simple(layer_copy,ORIENTATION_HORIZONTAL,TRUE,0)
	flake_layer = pdb.gimp_image_merge_down(image,layer_copy,EXPAND_AS_NECESSARY)



	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_alpha_to_snowflake",                           
	"Alpha to Snowflake",
	"Alpha to Snowflake",
	"Tin Tran",
	"Tin Tran",
	"July 2021",
	"<Image>/Python-Fu/Alpha To Snowflake...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "points", "Points/Divisions:", 6, (3, 100, 1)),
	],
	[],
	python_alpha_to_snowflake)

main()
