#!/usr/bin/env python
# coding=utf-8
# -*- encoding: utf-8 -*-
# alpha-transfer.py Rel 1
# Created by Tin Tran
# Comments directed to http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import random
from gimpfu import *
#import math
#import time
# the below is for getting a random texture layer from unsplash.
#import re, tempfile
#import urllib
#import urllib2
#import ssl
#import os

def python_alpha_transfer(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#index 0 is top most layer
	layer_with_alpha = image.layers[0]
	
	#index 1 is next layer below it
	transfer_to = image.layers[1]

	#select item which is the layer with alpha is the same as doing front end "Alpha to Selection"
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,layer_with_alpha)

	#create a mask for transfer_to layer using the current selection
	mask = pdb.gimp_layer_create_mask(transfer_to,ADD_MASK_SELECTION)

	#adds the mask after it's created
	pdb.gimp_layer_add_mask(transfer_to,mask)

	#removes the mask applying it
	pdb.gimp_layer_remove_mask(transfer_to,MASK_APPLY)

	#selection NONE
	pdb.gimp_selection_none(image)



	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	pdb.gimp_message("Complete!")
	#return

register(
	"python_fu_alpha_transfer",
	"Transfers layer's alpha to another layer as mask and apply it",
	"Transfers layer's alpha to another layer as mask and apply it",
	"Tin Tran",
	"Tin Tran",
	"Sept 6 2022",
	"<Image>/Python-Fu/Alpha Transfer...",             #Menu path
	"RGB*, GRAY*",
	[
	#(PF_BRUSH, "brush", "Brush:", 0),
	#(PF_SPINNER, "width", "Estimated Piece Width:", 300, (10, 1000, 1)),
	#(PF_SPINNER, "length", "Estimated Piece Length:", 800, (10, 1000, 1)),
	#(PF_SPINNER, "offset_angle", "Offset angle (90 is default because we default a collage shape generally vertically):", 90, (0,360, 1)),
	#(PF_TOGGLE, "random_angle",   "Use random angle (when doing generally round blotches):", 0),
	#(PF_SPINNER, "px_height", "Height of each tile image:", 100, (1, 1000, 50)),
	],
	[],
	python_alpha_transfer)

main()
