#!/usr/bin/env python

# average_color_rip.py Rel 1
# goal here is to turn a current selection into a paper rip of average color of 'Source' layer.
# Created by Tin Tran
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release
from gimpfu import *
#========================================
def python_average_color_rip(image, layer, rip_edge_color, numpoints, maxstray) : #FUNCTION DEFINITION
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#YOUR CODE BEGINS=======================
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
	if non_empty:
		#fill with edge color
		pdb.python_fu_random_rip(image,layer,numpoints,maxstray)
		pdb.gimp_context_set_foreground(rip_edge_color)
		pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
		#fill with average color
		pdb.python_fu_random_rip(image,layer,numpoints,maxstray)
		pdb.python_fu_tt_draw_average(image,layer)
	else:
		pdb.gimp_message("You need to make a selection")
	#YOUR CODE ENDS ========================
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_average_color_rip",
	"Average Color Rip",
	"Average Color Rip...",
	"Tin Tran",
	"Tin Tran",
	"Oct 2017",
	"<Image>/Python-Fu/Average Color Rip...",
	"*",      # Create a new image, don't work on an existing one
	[ 
	#INPUT BEGINS
	(PF_COLOR, "ripedgecolor", "Rip Edge Colour:", (255, 255, 255) ), # extra param is RGB triple
	(PF_SPINNER, "numpoints", "Number of points (to randomly shift per stroke to create rough edges):", 100, (10, 5000, 1)),
	(PF_SPINNER, "maxstray", "Max Stray Pixels:", 20, (1, 100, 1)),
	#(PF_STRING, "code", "Code to Run:", "pdb.script_fu_drop_shadow(image,layer,4,4,15,(0,0,0),60,False)"),
	#(PF_OPTION, "arrow_side", "Arrows Ends:", SIDE_END, SIDE_NAMES),
	#(PF_TOGGLE, "arrow_close", "Arrows Close:", 0),
	#(PF_SPINNER, "border_width", "Border Width (bevelled width):", 10, (0, 500, 1)),
	#(PF_SPINNER, "shadow_offset_x", "Shadow Offset X:", 6, (-4096,4096,1)),
	#(PF_SPINNER, "shadow_offset_y", "Shadow Offset Y:", 6, (-4096,4096,1)),
	#(PF_SPINNER, "shadow_blur_radius", "Shadow Blur Radius:", 15, (0,1024,1)),
	#(PF_SPINNER, "shadow_opacity", "Shadow Opacity:", 100, (0,100,1)),
	#INPUT ENDS
	],
	[],
	python_average_color_rip)

main()
