#!/usr/bin/env python

# circle_paint.py Release 1
# Created by Tin Tran http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
from gimpfu import *
import random
import math
#from array import array
#import sys
'''def pcount(p):
	total = 0
	for xc in range(0,len(p)):
		for yc in range(0,len(p[xc])):
			total += p[xc][yc]
	return total
'''
def python_tt_circle_paint(image, layer, circlesnum):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#core code goes here/below

	#initialize 
	#p = []
	#for y in range(0,layer.height):
	#	row = []
	#	for x in range(0,layer.width):
	#		row.append(0)
	#	p.append(row)
	
	#total_length = layer.width * layer.height
	pdb.gimp_progress_init("Processing image...",None)
	#p_count = pcount(p)
	circles = []
	count = 0
	while True:
		count += 1

		pdb.gimp_progress_update(float(count)/circlesnum)
		x = random.randrange(0,int(layer.width))
		y = random.randrange(0,int(layer.height))
		#pdb.gimp_message(str(x)+ ":"+str(y))
		#while p[y][x] == 1:
		#	x += 1
		#	if x >= layer.width: #loop to next line
		#		x = 0
		#		y += 1
		#		if y >= layer.height: #loop around to beginning of image
		#			y = 0

		#x = int(x)
		#y = int(y)			
		#pdb.gimp_message(str(x)+ ":"+str(y))
		pdb.gimp_fuzzy_select(layer,x,y,5,CHANNEL_OP_REPLACE,TRUE,FALSE,0,FALSE)
		non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
		#pdb.gimp_message(str(x)+ ":"+str(y))
		#pdb.gimp_message("non_empty" + str(non_empty))
		if non_empty:
			#area = 0	
			#for yi in range(int(y1),int(y2+1)):
				##pdb.gimp_progress_update(pcount(p)*1.0/total_length)
				#for xi in range(int(x1),int(x2+1)):
					#if pdb.gimp_selection_value(image,xi,yi) > 0:
						#p[yi][xi] = 1
						#area += 1
						
			#sels.append(sel)

			#fill selection with average color
			r, _, _, _, _, _ = pdb.gimp_histogram(layer,HISTOGRAM_RED,0,255)
			g, _, _, _, _, _ = pdb.gimp_histogram(layer,HISTOGRAM_GREEN,0,255)
			b, _, _, _, area, _ = pdb.gimp_histogram(layer,HISTOGRAM_BLUE,0,255)

			circles.append([area,(x,y),(int(r),int(g),int(b))])

			#pdb.gimp_context_set_foreground((int(r),int(g),int(b)))
			#pdb.gimp_edit_fill(work_layer,FOREGROUND_FILL)
			
			#paint around the path/vector then remove it

			#pdb.plug_in_sel2path(image,layer)
			#pdb.gimp_selection_none(image)
			#if len(image.vectors) > 0:
			#	vectors = image.vectors[0]
			#	pdb.gimp_drawable_edit_stroke_item(work_layer,vectors)
				#pdb.gimp_edit_stroke_vectors(work_layer,vectors)
			#	pdb.gimp_image_remove_vectors(image,vectors)
		else:
			#pdb.gimp_message("no selection, setting to 1")
			#pdb.gimp_message("no selection")
			pass
			#p[y][x] = 1	

		#p_count = pcount(p)
		#pdb.gimp_message("pcount:" + str(p_count))

		if count > circlesnum:
			break
		#if p_count >= total_length:
		#	break
	
	pdb.gimp_progress_init("Sorting circles...",None)
	sorted_circles = sorted(circles,key=lambda x: -x[0])
	work_layer = pdb.gimp_layer_new(image,layer.width,layer.height,RGBA_IMAGE,"circles layer",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image,work_layer,None,0)
	num_circles = len(sorted_circles)
	pdb.gimp_progress_init("Painting circles...",None)
	for c in range(0,num_circles):
		pdb.gimp_progress_update(c*1.0/num_circles)
		circle = sorted_circles[c]
		radius = (circle[0] / math.pi)**0.5
		cx = circle[1][0]
		cy = circle[1][1]
		pdb.gimp_image_select_ellipse(image,CHANNEL_OP_REPLACE,cx-radius,cy-radius,radius*2.0,radius*2.0)
		pdb.gimp_context_set_foreground(circle[2]) #color is at index 2
		pdb.gimp_edit_fill(work_layer,FOREGROUND_FILL)
	
	#desaturate
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	#return

register(
	"python_fu_tt_circle_paint",                           
	"Creates Circle Painting out of active layer",
	"Creates Circle Painting out of active layer",
	"Tin Tran",
	"Tin Tran",
	"May 2019",
	"<Image>/Python-Fu/Circle Paint...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "circlesnum", "Number of circles:", 1000, (100, 100000, 1)),
	#(PF_SPINNER, "frame_percent", "Frame percentage (percent to grow by to create border):", 10, (5, 100, 1)),
	#(PF_TOGGLE, "keep_aspect", "Keep Aspect Ratio of Border:", 1),
	#(PF_TOGGLE, "mirror","Mirror/Reflect Borders:", 1),
	#(PF_TOGGLE, "drop_shadow","Drop Shadow:", 1),
	#(PF_SPINNER, "shadow_offset_x", "Shadow Offset X:", 2, (-1000, 1000, 1)),
	#(PF_SPINNER, "shadow_offset_y", "Shadow Offset Y:", 2, (-1000, 1000, 1)),
	#(PF_SPINNER, "shadow_blur", "Shadow Blur Radius:", 15, (0, 1000, 1)),
	#(PF_SPINNER, "shadow_opacity", "Shadow Opacity:", 60, (0, 100, 1)),
	],
	[],
	python_tt_circle_paint)

main()
