#!/usr/bin/env python

# match_squares.py Rel 1
# This plug-in will try to compose selected layer with collage paper layer
# It'll random pick a square and try to match up with closest match then mark it as used so it doesn't use it again

# Created by Tin Tran http://gimplearn.net
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Faster version.
#import string
#import Image
import random
import math
#from array import array
import sys
from gimpfu import *
def choose(colors,chose): #returns number combinations when we choose number colors (chose 2)
    return int(math.factorial(colors)/math.factorial(colors-chose)/math.factorial(chose))
def draw_tiles(img,lay,x,y,col1,col2,dimension):
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,x,y,dimension*34,dimension)
	pdb.gimp_context_set_foreground(col1)
	pdb.gimp_edit_fill(lay,FILL_FOREGROUND)
	pdb.gimp_context_set_foreground(col2)
	#tile1
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_REPLACE,6,[xmid,ymid,x2,y2,x1,y2])
	#tile2
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,ymid,x2,y1,x1,y1])
	#tile3
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,y1,x2,ymid,xmid,y2])
	#tile4
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,y1,x1,ymid,xmid,y2])
	#tile31
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,y1,x2,ymid,x1,ymid])
	#tile32
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,y2,x2,ymid,x1,ymid])
	#tile33
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x1,y1,xmid,ymid,x1,y2])
	#tile34
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x2,y1,xmid,ymid,x2,y2])


	#tile5
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x1,y1,x2,y1,x1,y2])
	#tile6
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x1,y1,x2,y1,x2,y2])
	#tile7 diamond
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[xmid,y1,x2,ymid,xmid,y2,x1,ymid])
	#tile8
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[x1,y1,xmid,y1,x2,ymid,xmid,y2,x1,ymid])
	#tile9
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[xmid,y1,x2,y1,x2,ymid,xmid,y2,x1,ymid])
	#tile10
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[xmid,y1,x2,ymid,xmid,y2,x1,y2,x1,ymid])
	#tile11
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[xmid,y1,x2,ymid,x2,y2,xmid,y2,x1,ymid])
	#tile12
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,y1,xmid,y1,xmid,y2,x1,y2])
	#tile13
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x2,y1,xmid,y1,xmid,y2,x2,y2])
	#tile14
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,y1,x2,y1,x2,ymid,x1,ymid])
	#tile15
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,y2,x2,y2,x2,ymid,x1,ymid])
	#tile16
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,y1,xmid,y1,xmid,ymid,x1,ymid])
	#tile17
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[xmid,y1,x2,y1,x2,ymid,xmid,ymid])
	#tile18
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,ymid,xmid,ymid,xmid,y2,x1,y2])
	#tile19
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[xmid,ymid,xmid,y2,x2,y2,xmid,y2])
	#tile20
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,8,[x1,y1,x2,y1,x2,y2,x1,y2])
	#tile21
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[xmid,y1,x2,ymid,x2,y2,x1,y2,x1,ymid])
	#tile22
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[x1,y1,xmid,y1,x2,ymid,xmid,y2,x1,y2])
	#tile23
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[x1,y1,x2,y1,x2,ymid,xmid,y2,x1,ymid])
	#tile24
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,10,[xmid,y1,x2,y1,x2,y2,xmid,y2,x1,ymid])
	#tile25
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,12,[x1,y1,xmid,y1,x2,ymid,x2,y2,xmid,y2,x1,ymid])
	#tile26
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,12,[xmid,y1,x2,y1,x2,ymid,xmid,y2,x1,y2,x1,ymid])
	#tile27
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x1,y1,xmid,y1,x1,ymid])
	#tile28
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[xmid,y1,x2,y1,x2,ymid])
	#tile29
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x2,ymid,x2,y2,xmid,y2])
	#tile30
	x1=x; x2=x+dimension; xmid=x+dimension/2; y1=y; y2=y+dimension; ymid=y+dimension/2; x+=dimension; #x+for next tile
	pdb.gimp_image_select_polygon(img,CHANNEL_OP_ADD,6,[x1,ymid,xmid,y2,x1,y2])
	
				

	#MORE TODO
	pdb.gimp_edit_fill(lay,FILL_FOREGROUND)
def python_tt_create_squares(image, layer, colors, dimension):
	colors = int(colors)
	dimension = int(dimension)
	pdb.gimp_image_convert_indexed(image,CONVERT_DITHER_NONE,CONVERT_PALETTE_GENERATE,colors,FALSE,FALSE,"PALETTE NAME/UNUSED")
	num_bytes,colormap = pdb.gimp_image_get_colormap(image)
	num_bytes = int(num_bytes/colors)
	width = 34 * dimension #number of tiles variations * dimension
	height = choose(colors,2) * 2 * dimension
	new_image = pdb.gimp_image_new(width,height,RGB)
	#create new image and new layer to work with
	new_layer = pdb.gimp_layer_new(new_image,width,height,RGBA_IMAGE,"Squares",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	pdb.gimp_display_new(new_image)
	y = 0
	for c1 in range(0,colors-1):
		for c2 in range(c1+1,colors):
			color1 = (colormap[c1*num_bytes+0],colormap[c1*num_bytes+1],colormap[c1*num_bytes+2])
			color2 = (colormap[c2*num_bytes+0],colormap[c2*num_bytes+1],colormap[c2*num_bytes+2])
			draw_tiles(new_image,new_layer,0,y,color1,color2,dimension)
			draw_tiles(new_image,new_layer,0,y+dimension,color2,color1,dimension)
			y += dimension*2	#increment y for next round of tiles of different color combinations
	pdb.gimp_displays_flush()

register(
	"python_fu_tt_create_squares",                           
	"Create Squares pattern to be used with AA Match Squares",
	"Create Squares pattern to be used with AA Match Squares",
	"Tin Tran",
	"Tin Tran",
	"July 2021",
	"<Image>/Python-Fu/AA Create Squares...",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_DRAWABLE, "paper_layer", "(Collage) Paper Layer (to use):", None),
	(PF_SPINNER, "colors", "# Of Indexed Colors:", 10, (2, 50, 1)),
	(PF_SPINNER, "dimension", "Square Dimension(pixels):", 50, (5, 250, 1)),
	],
	[],
	python_tt_create_squares)

main()
