#!/usr/bin/env python

# cut-frame.py
# selects frame then clear everything that's not within the frame on selected layer
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random

def python_cut_frame(image, layer, imagetocut) :
	pdb.gimp_fuzzy_select_full(layer,layer.width/2,layer.height/2,42.7,CHANNEL_OP_REPLACE,TRUE,FALSE,0,0,FALSE,TRUE,SELECT_CRITERION_COMPOSITE)
	#pdb.gimp_image_select_contiguous_color(image,CHANNEL_OP_REPLACE,layer,layer.width/2,layer.height/2)
	pdb.gimp_selection_grow(image,1)
	pdb.gimp_image_select_item(image,CHANNEL_OP_ADD,layer)
	pdb.gimp_selection_invert(image)
	pdb.gimp_edit_clear(imagetocut)
	pdb.gimp_displays_flush()


register(
	"python_fu_cut_frame",
	"Cut Frame",
	"Cut Frame",
	"Tin Tran",
	"Tin Tran",
	"November 2019",
	"<Image>/Python-Fu/Cut Frame...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	(PF_DRAWABLE, "imagetocut", "Layer to cut to frame:", None),
	],
	[],
	python_cut_frame)

main()
