#!/usr/bin/env python

# foreground-color-colorize.py
# to solve this problem: https://gimplearn.net/viewtopic.php?f=9&t=2586
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
import colorsys
from gimpfu import *
def python_foreground_color_colorize(image, layer, colorize_color, option) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	if option == 0:
		color = colorize_color
	elif option == 1:
		color = pdb.gimp_context_get_foreground()
	elif option == 2:
		color = pdb.gimp_context_get_background()

	h,l,s = colorsys.rgb_to_hls(color[0]/255.0,color[1]/255.0,color[2]/255.0)
	Hue = h * 360.0
	Saturation = s * 100.0
	Lightness = l * 200.0 - 100.0
	pdb.gimp_drawable_colorize_hsl(layer,Hue,Saturation,Lightness)
	#colorsys.rgb_to_hls
	''' console executed to test colorsys.rgb_to_hls results
	>>> colorsys.rgb_to_hls(1,1,1)
	(0.0, 1.0, 0.0)
	>>> colorsys.rgb_to_hls(0,1,1)
	(0.5, 0.5, 1)
	>>> colorsys.rgb_to_hls(0,0,1)
	(0.6666666666666666, 0.5, 1)
	>>> colorsys.rgb_to_hls(0,0,0)
	(0.0, 0.0, 0.0)
	'''
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()

register(
	"python_fu_foreground_color_colorize",
	"Colorize using foreground",
	"Colorize using foreground",
	"Tin Tran",
	"Tin Tran",
	"November 2019",
	"<Image>/Python-Fu/Foreground-color-colorize",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_COLOR, "color", "Colorize color:", (100, 21, 40) ),
	#defaulting 1st time call to foreground color.
	(PF_COLOR, "color", "Colorize color:", (255,0,0)),
	(PF_OPTION,"option",   "What color to use:", 1, ["Use above colorize color","Use foreground color","Use background color"])
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_foreground_color_colorize)

main()
