#!/usr/bin/env python

# get_average_color.py Release 1
# It will get average color of selected area on active layer, if no selection exists it'll get average color of whole layer.
# Created by Tin Tran http://gimplearn.net
# Comments directed to http://gimplearn.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import random
#import string
#import Image
from gimpfu import *
#from array import array
#import sys

def python_tt_get_average_color(image, layer):
	gimp_version = pdb.gimp_version()
	if gimp_version.startswith("2.10"):
		r, _, _, _, _, _ = pdb.gimp_drawable_histogram(layer,HISTOGRAM_RED,0,1)
		g, _, _, _, _, _ = pdb.gimp_drawable_histogram(layer,HISTOGRAM_GREEN,0,1)
		b, _, _, _, _, _ = pdb.gimp_drawable_histogram(layer,HISTOGRAM_BLUE,0,1)
		pdb.gimp_context_set_foreground((int(r),int(g),int(b)))
	elif gimp_version.startswith("2.8"):
		r, _, _, _, _, _ = pdb.gimp_histogram(layer,HISTOGRAM_RED,0,255)
		g, _, _, _, _, _ = pdb.gimp_histogram(layer,HISTOGRAM_GREEN,0,255)
		b, _, _, _, _, _ = pdb.gimp_histogram(layer,HISTOGRAM_BLUE,0,255)
		pdb.gimp_context_set_foreground((int(r),int(g),int(b)))
	else:
		pdb.gimp_message("GIMP version neither 2.8 or 2.10. We don't know what to do!")
register(
	"python_fu_tt_get_average_color",                           
	"Fills selection of active layer with average color of selection on layer named 'Source'",
	"Fills selection of active layer with average color of selection on layer named 'Source'",
	"Tin Tran",
	"Tin Tran",
	"June 2019",
	"<Image>/Python-Fu/Get Average Color",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_SPINNER, "grow", "Pixels to grow each area before intersecting with original selection:", 2, (0, 100, 1)),
	#(PF_TOGGLE, "brushit", "Edit-Blend instead of Edit-Fill (Edit-blend is faster):", 1),
	#(PF_SPINNER, "brushsize", "Brush Size:", 500, (100, 10000, 1)),
	#(PF_TOGGLE, "dodge", "Dodge filled areas (Subtract alpha to selection's selection):", 0),
	],
	[],
	python_tt_get_average_color)

main()