#!/usr/bin/env python

# glow_stick_effect.py Release 1
# Created by Tin Tran http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
from gimpfu import *
import random
#from array import array
#import sys
def python_tt_glow_stick_effect(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#core code goes here/below
	
	#desaturate
	pdb.gimp_drawable_desaturate(layer,DESATURATE_LUMINANCE)
	
	pdb.python_fu_tt_split_tone(image,layer,(199,14,0),(255,220,170))
	#get layers created by split tone plug in
	dark_tone_layer = pdb.gimp_image_get_layer_by_name(image,"dark tone")
	light_tone_layer = pdb.gimp_image_get_layer_by_name(image,"light tone")
	pdb.gimp_selection_none(image)
	
	#fill dark tone and light tone with appropriate colors and set opacity to 50% 
	#and flatten image so that we're left with one layer
	pdb.gimp_context_set_foreground((199,14,0))
	pdb.gimp_edit_fill(dark_tone_layer,FILL_FOREGROUND)
	pdb.gimp_context_set_foreground((255,220,170))
	pdb.gimp_edit_fill(light_tone_layer,FILL_FOREGROUND)
	pdb.gimp_layer_set_opacity(dark_tone_layer,50)
	pdb.gimp_layer_set_opacity(light_tone_layer,50)
	layer = pdb.gimp_image_flatten(image)

	#invert and adjust hue and saturation
	pdb.gimp_drawable_invert(layer,FALSE)
	pdb.gimp_drawable_hue_saturation(layer,HUE_RANGE_ALL,-45,0,25,0)


	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_tt_glow_stick_effect",                           
	"Creates Glow Stick Effect",
	"Creates Glow Stick Effect",
	"Tin Tran",
	"Tin Tran",
	"May 2019",
	"<Image>/Python-Fu/Glow Stick Effect",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_SPINNER, "frame_percent", "Frame percentage (percent to grow by to create border):", 10, (5, 100, 1)),
	#(PF_TOGGLE, "keep_aspect", "Keep Aspect Ratio of Border:", 1),
	#(PF_TOGGLE, "mirror","Mirror/Reflect Borders:", 1),
	#(PF_TOGGLE, "drop_shadow","Drop Shadow:", 1),
	#(PF_SPINNER, "shadow_offset_x", "Shadow Offset X:", 2, (-1000, 1000, 1)),
	#(PF_SPINNER, "shadow_offset_y", "Shadow Offset Y:", 2, (-1000, 1000, 1)),
	#(PF_SPINNER, "shadow_blur", "Shadow Blur Radius:", 15, (0, 1000, 1)),
	#(PF_SPINNER, "shadow_opacity", "Shadow Opacity:", 60, (0, 100, 1)),
	],
	[],
	python_tt_glow_stick_effect)

main()
