#!/usr/bin/env python

# grid-of-guides.py Rel 1
# Created by Tin Tran 
# Comments directed to http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Genft-artneral Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.

from gimpfu import *

def python_guides_grid_tt(image, layer, xtiles, ytiles):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	xtiles = int(xtiles)
	ytiles = int(ytiles)
	tilewidth = image.width/xtiles
	for xguide in range(0,xtiles+1):
		x = xguide * tilewidth
		pdb.gimp_image_add_vguide(image,x)

	tileheight = image.height/ytiles	
	for yguide in range(0,ytiles+1):
		y = yguide * tileheight
		pdb.gimp_image_add_hguide(image,y)

	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	#return

register(
	"python_fu_guides_grid_tt",                           
	"Create Grid of Guides",
	"Create Grid of Guides",
	"Tin Tran",
	"Tin Tran",
	"March 13, 2022",
	"<Image>/Image/Guides/Grid of Guides...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "xtiles", "X-tiles (Horizontal):", 5, (1, 200, 1)),  # alias PF_ADJUSTMENT
	(PF_SPINNER, "ytiles", "Y-tiles (Vertical):", 5, (1, 200, 1)),  # alias PF_ADJUSTMENT
	],
	[],
	python_guides_grid_tt)

main()
