#!/usr/bin/env python

# jasmer_2 Rel 1
# Steps outlined by jasmer here: https://www.gimplearn.net/viewtopic.php/GIMP-Script-Requests/Simplifying-a-tedious-process-?f=18&t=1354
# Created by Tin Tran http://gimplearn.net/
# Comments directed to http://gimplearn.net or http://gimp-forum.net or http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.

from gimpfu import *

def python_tt_jasmer_2(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#Layer mode: Grain Merge, duplicate layer, merge down. That's it. I can do the rest manually.
	pdb.gimp_layer_set_mode(layer,GRAIN_MERGE_MODE)
	duplicated_layer = pdb.gimp_layer_new_from_drawable(layer,image)
	position = pdb.gimp_image_get_item_position(image,layer)
	pdb.gimp_image_insert_layer(image,duplicated_layer,None,position)
	pdb.gimp_image_merge_down(image,duplicated_layer,EXPAND_AS_NECESSARY)
		
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_tt_jasmer_2",                           
	"Steps outlined by jasmer 2",
	"Steps outlined by jasmer 2",
	"Tin Tran",
	"Tin Tran",
	"April 2018",
	"<Image>/Python-Fu/Jasmer Grain Merge Duplicate Merge Down...",             #Menu path
	"RGB*, GRAY*", 
	[
	#(PF_DRAWABLE, "reflect_layer", "Reflect layer:", None),
	#(PF_SPINNER, "z_distance", "Z Distance (How far your reflect layer is):", 0.01, (1.0, 1000, 0.01)),
	#(PF_SPINNER, "scale", "heightmap scale:", 1.0, (0.01, 1000, 0.01)),
	#(PF_FILENAME, "spherical_emap_png", "Spherical Emap (png/jpg):", "none"),
	],
	[],
	python_tt_jasmer_2)

main()
