#!/usr/bin/env python

# krikor-color-cast-reduction.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
#import random
#import math
#import os
#from array import array #needed for array pixel access

def python_krikor_color_cast_reduction(image,layer) :
	#1. duplicate layer
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,image);
	pdb.gimp_image_insert_layer(image,layer_copy,None,0)
	#2. blur pixelize with image width and image height
	pdb.plug_in_pixelize2(image,layer_copy,layer_copy.width,layer_copy.height)
	#3. colors - invert
	pdb.gimp_drawable_invert(layer_copy,FALSE) #FALSE for Linear
	#4. change layer mode to overlay
	pdb.gimp_layer_set_mode(layer_copy,LAYER_MODE_OVERLAY)
	#5. new from visible
	visible = pdb.gimp_layer_new_from_visible(image,image,'visible')
	pdb.gimp_image_insert_layer(image,visible,None,0)
	#6. remove alpha from visible
	#how the heck do we remove alpha if there is no method to call..I guess I'll just manually do it
	#by copy the layer's content
	
	layer_copy2 = pdb.gimp_layer_new(image,layer.width,layer.height,RGB_IMAGE,'Visible',100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image,layer_copy2,None,0)
	pdb.gimp_selection_all(image)
	pdb.gimp_edit_copy(visible)
	pdb.gimp_selection_none(image)
	floating_sel = pdb.gimp_edit_paste(layer_copy2,FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	#7. Color Levels -Auto deprecated, using drawable levels stretch it says to do
	pdb.gimp_drawable_levels_stretch(layer_copy2)
	#Delete visible layer
	pdb.gimp_image_remove_layer(image,visible)

register(
	"python_fu_krikor_color_cast_reduction",
	"Krikor Color Cast Reduction",
	"Krikor Color Cast Reduction",
	"Tin Tran",
	"Tin Tran",
	"June 2021",
	"<Image>/Python-Fu/Krikor Color Cast Reduction...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	#(PF_DRAWABLE, "shape", "Shape layer (with Alpha):", None),
	#(PF_TOGGLE, "mergedown",   "Merge Down layers:", 1),
	#(PF_OPTION,"option",   "Unused Input:", 0, ["To show Progress Bar"]),
	],
	[],
	python_krikor_color_cast_reduction)

main()
