#!/usr/bin/env python

# layers-border.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
import os
def python_layers_border_tt(image,layer,borderwidth,color,delete) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_context_set_foreground(color)
	#loop through and fill border with foreground color
	for layer in image.layers:
		if not layer.has_alpha:
			pdb.gimp_layer_add_alpha(layer)
		#first select all then subtract the inner rectangle (to select border with borderwidth)
		pdb.gimp_selection_all(image)
		pdb.gimp_image_select_rectangle(image,CHANNEL_OP_SUBTRACT,borderwidth,borderwidth,layer.width-(borderwidth*2),layer.height-(borderwidth*2))
		pdb.gimp_edit_fill(layer,FILL_FOREGROUND)
		if (delete == 1):
			pdb.gimp_selection_invert(image)
			pdb.gimp_edit_clear(layer)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_layers_border_tt",
	"Add layers border to image and optionally delete image",
	"Add layers border to image and optionally delete image",
	"Tin Tran",
	"Tin Tran",
	"Sept 2020",
	"<Image>/Python-Fu/Layers Border...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	#(PF_DRAWABLE, "shape", "Shape layer (with Alpha):", None),
	(PF_SPINNER, "borderwidth", "Border Width (To Select):", 15, (1, 1000, 50)),
	(PF_COLOR, "color", "Border Color:", (0, 0, 0) ),
	(PF_TOGGLE, "delete",   "Delete Inner Image Content:", 1),
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[],
	python_layers_border_tt)

main()
