#!/usr/bin/env python

# map-scale-legend.py Rel 2
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
# This is an attempt to translate from scheme script-fu found at
# https://www.cartographersguild.com/showthread.php?t=5820
# 
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Make text shown on top, and only show 1cm, custom for Morpheus
import math
import string
#import Image
from gimpfu import *
from array import array
PIXELS = 0

def marcos2(theImage, theLayer, x, inW, inStep, inB, inH, inDouble, inU, inSU, steps, inFontSize, inFont, inFC):
	pdb.gimp_rect_select(theImage,(x+inB),inB,inStep,inH,CHANNEL_OP_REPLACE,0,0)
	pdb.gimp_edit_fill(theLayer,BACKGROUND_FILL)
	if inDouble==1:
		pdb.gimp_rect_select(theImage,(x+inB),inB,inStep,((inH+1)/2),CHANNEL_OP_REPLACE,0,0)
		pdb.gimp_edit_fill(theLayer,FOREGROUND_FILL)
	if steps+1 == 1:
		text = pdb.gimp_text_fontname(theImage,None,((x+inB)-1),(inH+inB+inB),str(int(steps+1))+" "+inU,0,0,inFontSize,0,inFont)
		pdb.gimp_layer_translate(text,0,-(text.height * 1.8))
		pdb.gimp_text_layer_set_color(text,inFC)
		pdb.gimp_image_merge_down(theImage,text,EXPAND_AS_NECESSARY)
	
	if x <= inW:
		marcos1(theImage,theLayer,(x+inStep),inW,inStep,inB,inH,inDouble,inU,inSU,(steps+inSU),inFontSize,inFont,inFC)
		

def marcos1(theImage, theLayer, x, inW, inStep, inB, inH, inDouble, inU, inSU, steps, inFontSize, inFont, inFC):
	pdb.gimp_rect_select(theImage,(x+inB),inB,inStep,inH,CHANNEL_OP_REPLACE,0,0)
	pdb.gimp_edit_fill(theLayer,FOREGROUND_FILL)
	if inDouble == 1:
		pdb.gimp_rect_select(theImage,(x+inB),inB,inStep,((inH+1)/2),CHANNEL_OP_REPLACE,0,0)
		pdb.gimp_edit_fill(theLayer,BACKGROUND_FILL)
	if steps+1 == 1:
		text = pdb.gimp_text_fontname(theImage,None,((x+inB)-1),(inH+inB+inB),str(int(steps+1)) +" "+ inU,0,0,inFontSize,0,inFont)
		pdb.gimp_layer_translate(text,0,-(text.height * 1.8))
		pdb.gimp_text_layer_set_color(text,inFC)
		pdb.gimp_image_merge_down(theImage,text,EXPAND_AS_NECESSARY)
	
	if (x <= inW):
		marcos2(theImage,theLayer,(x + inStep),inW,inStep,inB,inH,inDouble,inU,inSU,(steps+inSU),inFontSize,inFont,inFC)

def python_map_scale_legend(image, layer, inH, inW, inStep, inSU, inU, inDouble, inB, inBC, inC1, inC2, inFont, inFontSize, inFC, inFSC):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#pdb.gimp_message("This is sample shell script.")
	#PUT YOUR CODE HERE 
	theImage = pdb.gimp_image_new((inW + inB + inB),(inH + inB + inB),RGB)
	fondo = pdb.gimp_layer_new(theImage,(inW + inB + inB),(inH + inB + inB), RGB_IMAGE, "Frame", 100, NORMAL_MODE)
	theLayer = pdb.gimp_layer_new(theImage,inW,inH,RGBA_IMAGE,"ZigZag",100,NORMAL_MODE)
	textLayer = pdb.gimp_layer_new(theImage,10,10,RGBA_IMAGE,"text",100,NORMAL_MODE)
	
	pdb.gimp_image_insert_layer(theImage,fondo,None,-1)
	pdb.gimp_image_insert_layer(theImage,theLayer,None,-1)
	pdb.gimp_image_insert_layer(theImage,textLayer,None,-1)
	pdb.gimp_layer_set_offsets(theLayer,inB,inB)
	
	pdb.gimp_context_set_foreground(inC1)
	
	#borde
	pdb.gimp_context_set_background(inBC)
	pdb.gimp_drawable_fill(fondo,BACKGROUND_FILL)
	
	#marcos
	pdb.gimp_context_set_foreground(inC1)
	pdb.gimp_context_set_background(inC2)
	marcos1(theImage,theLayer,0,(inW - inStep),inStep,inB,inH,inDouble,inU,inSU,0,inFontSize,inFont,inFC)
	
	#add shadow to text layer
	active_layer = pdb.gimp_image_get_active_layer(theImage)
	tw = pdb.gimp_drawable_width(active_layer)
	th = pdb.gimp_drawable_height(active_layer)
	pdb.gimp_layer_resize(active_layer,(tw + 2),(th+2),1,1)
	pdb.gimp_context_set_foreground(inFSC)
	shadowLayer = pdb.gimp_layer_copy(active_layer,1)
	pdb.gimp_image_insert_layer(theImage,shadowLayer,None,-1)
	pdb.gimp_image_lower_item(theImage,shadowLayer)
	pdb.gimp_image_resize_to_layers(theImage)
	pdb.gimp_image_select_item(theImage,CHANNEL_OP_REPLACE,shadowLayer)
	pdb.gimp_selection_grow(theImage,1)
	pdb.gimp_edit_fill(shadowLayer,FOREGROUND_FILL)
	
	#fin
	pdb.gimp_image_resize_to_layers(theImage)
	pdb.gimp_image_merge_visible_layers(theImage,EXPAND_AS_NECESSARY)
	pdb.gimp_selection_none(theImage)
	theDisplay = pdb.gimp_display_new(theImage)
	pdb.gimp_image_clean_all(theImage)
	
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	
	return (theImage,theDisplay);

register(
	"python_fu_map_scale_legend",                           
	"draws Map Scale Legend",
	"draws Map Scale Legend, returns newImage,Display...",
	"Tin Tran translated from Alejandro Grijalba's scheme script",
	"Tin Tran translated from Alejandro Grijalba's scheme script",
	"2016",
	"<Image>/Python-Fu/Map Scale Legend...",             #Menu path
	"", 
	[
	#inH inW inStep inSU inU inDouble inB inBC inC1 inC2 inFont inFontSize 
	#inFC inFSC
	(PF_SPINNER, "inH", "Height:", 14, (1, 200, 1)), 
	(PF_SPINNER, "inW", "Width:", 200, (1, 4096, 1)),
	(PF_SPINNER, "inStep", "Step(px):", 50, (1, 1024, 1)),
	(PF_SPINNER, "inSU", "Step(unit):", 1, (1, 1024, 1)),
	(PF_STRING, "inU", "Unit name:", "km"),
	(PF_TOGGLE, "inDouble",   "Split bar:", 1),
	(PF_SPINNER, "inB", "Border Width:", 1, (0, 100, 1)),
	(PF_COLOR, "inBC", "Border Color:", (0, 0, 0)),
	(PF_COLOR, "inC1", "Color 1:", (255, 255, 255)),
	(PF_COLOR, "inC2", "Color 2:", (0, 0, 0)),
	(PF_FONT, "inFont", "Font:", "Charter"),
	(PF_SPINNER, "inFontSize", "Font Size:", 10, (1, 1000, 1)),
	(PF_COLOR, "inFC", "Font Color:", (0, 0, 0)),
	(PF_COLOR, "inFSC", "Font Shadow Color:", (255, 255, 255)),
	],
	[
	(PF_IMAGE, "theImage", "the newly created Image"),
	(PF_DISPLAY, "theDisplay", "the display that's created for the newly created Image")
	],
	python_map_scale_legend)

main()





