#!/usr/bin/env python

# nft-variations.py Rel 1
# Created by Tin Tran 
# Comments directed to http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import sys,os,os.path,traceback
from gimpfu import *
def python_nft_variations_tt(image, layer, variationstring,directory):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()

	#layers = ["1","2","A","B","C","X","Y"];
	#variationstring = "2,3,2";
	nums = variationstring.split(",")
	nums = list(map(int,nums)) #converts to numbers 
	element = 0;
	index = 1;
	objsgroups = [];
	objs = [];
	for layer in image.layers:
		if index <= nums[element]:
			objs.append(layer);

		index += 1;	#increment to next index
		if index > nums[element]: #for next time through the loop
			objsgroups.append(objs); #append it to objsgroup and reset it to hold current layer
			objs = [];
			index = 1;
			element += 1;
	counters = [];
	for i in range(0,len(nums)): #add a counter 0 for each objsgroup
		counters.append(0);
	filename_counter = 1;	
	while counters[0] < nums[0]: #while first counter is still in valid range
		#do work here of displaying here
		for layer in image.layers: #shut everything off
			pdb.gimp_item_set_visible(layer,FALSE)
		#set the combinations visible TRUE
		for i in range(0,len(counters)):
			layer = objsgroups[i][counters[i]]
			pdb.gimp_item_set_visible(layer,TRUE)
		visible_layer = pdb.gimp_layer_new_from_visible(image,image,"visible")
		pdb.gimp_image_insert_layer(image,visible_layer,None,0)

		fullname = str(filename_counter)+".png";
		filename=os.path.join(directory,fullname);
		pdb.file_png_save_defaults(image,visible_layer,filename,filename);
		pdb.gimp_image_remove_layer(image,visible_layer) #remove visible when done
		filename_counter+=1; #increment for next file name
		
		counters[len(nums)-1] += 1; #increment last counter
		for i in range(len(nums)-1,0,-1): #loop backward to see if can increment previous counter
			if counters[i]>=nums[i]:
				counters[i] = 0;
				counters[i-1] += 1;
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
	#return

register(
	"python_fu_nft_variations_tt",                           
	"Create NFT Variations from combinations of layers",
	"Create NFT Variations from combinations of layers",
	"Tin Tran",
	"Tin Tran",
	"January 13, 2022",
	"<Image>/Python-Fu/NFT Variations...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_STRING,"variationstring", "Variation String (Comma delimited):", "2,3,2"),
	(PF_DIRNAME,'directory','Output Directory','.'),
	],
	[],
	python_nft_variations_tt)

main()
