#!/usr/bin/env python

# omg brumby Rel 3
# This script runs on an active black and white drawing, and you'll have to choose background layer and gem file (gemclear.png) included in tutorial.
# idea from http://bakon.ca/gimplearn/omg-tutorial-clear-glass-brumbies-327
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimplearn.com or http://gimp-forum.net or http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2:...
# Rel 3: Constantized for GIMP 2.10
import math
import string
#import Image
from gimpfu import *
from array import array
import sys


def python_omg_brumby(image, layer, bg_layer, gem_file):
	global point_offsets
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#initial things we'll work with
	layer_name = pdb.gimp_item_get_name(layer)
	layer_position = pdb.gimp_image_get_item_position(image,layer)
	outline_layer_name = layer_name + " outline"
	pdb.gimp_context_set_pattern("3D Green")
	
	pdb.gimp_selection_none(image)
	pdb.gimp_item_set_visible(layer,False)
	pdb.gimp_by_color_select(layer,(255,255,255),15.0,CHANNEL_OP_REPLACE,True,False,0,False)
	pdb.gimp_selection_invert(image)
	
	outline_layer = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,outline_layer_name,100,LAYER_MODE_NORMAL_LEGACY)
	pdb.gimp_image_insert_layer(image,outline_layer,None,layer_position)
	pdb.gimp_edit_fill(outline_layer,FILL_PATTERN)
	highlights_layer_name = layer_name + " highlights"
	pdb.script_fu_ml_bevel_reflect_logo_alpha(image,outline_layer,1,8,10.0,7.0,20.0,1.00,0,5,1,gem_file,0,0,0,0,"Abstract 1",315,0.35,2,2.7,2.6,300,0,True,True,True)
	highlights_layer = pdb.gimp_image_get_layer_by_name(image,"BR Logo")
	br_logo_copy = pdb.gimp_image_get_layer_by_name(image,"BR Logo Copy")
	pdb.gimp_item_set_name(highlights_layer,highlights_layer_name)
	pdb.gimp_image_remove_layer(image,br_logo_copy)
	pdb.gimp_selection_none(image)
	
	#highlights_layer = pdb.gimp_image_get_layer_by_name(image,highlights_layer_name)
	pdb.gimp_fuzzy_select_full(highlights_layer,1,1,15.0,CHANNEL_OP_REPLACE,True,False,0,0,False,True,SELECT_CRITERION_COMPOSITE)
	pdb.gimp_selection_invert(image)
	
	fill_layer_name = layer_name + " fill"
	highlights_layer_position = pdb.gimp_image_get_item_position(image,highlights_layer)
	fill_layer = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,fill_layer_name,100,LAYER_MODE_NORMAL_LEGACY)
	pdb.gimp_image_insert_layer(image,fill_layer,None,highlights_layer_position)
	pdb.gimp_edit_fill(fill_layer,FILL_PATTERN)
	
	pdb.script_fu_ml_bevel_reflect_logo_alpha(image,fill_layer,2,8,10.0,7.0,20.0,1.00,0,10,2,gem_file,0,0,0,0,"Abstract 1",315,0.35,2,2.7,2.6,300,0,True,True,True)
	fill_layer = pdb.gimp_image_get_layer_by_name(image,"BR Logo")
	br_logo_copy = pdb.gimp_image_get_layer_by_name(image,"BR Logo Copy")
	pdb.gimp_item_set_name(fill_layer,fill_layer_name)
	pdb.gimp_image_remove_layer(image,br_logo_copy)
	pdb.gimp_selection_invert(image)
	pdb.gimp_edit_clear(fill_layer)
	pdb.gimp_image_lower_item(image,fill_layer)
	
	#create a copy of background.
	pdb.gimp_selection_invert(image)
	pdb.gimp_edit_copy(bg_layer)
	floating_sel = pdb.gimp_edit_paste(highlights_layer,False)
	pdb.gimp_floating_sel_to_layer(floating_sel)
	pdb.gimp_selection_none(image)
	pdb.gimp_layer_set_mode(floating_sel,LAYER_MODE_OVERLAY_LEGACY)
	pdb.gimp_item_set_name(floating_sel,layer_name + " background overlay")
	#perspective shadow 
	pdb.gimp_image_set_active_layer(image,fill_layer)
	pdb.script_fu_perspective_shadow(image,fill_layer,150.0,4.0,0.7,3,(0,0,0),60,1,False)
	shadow = pdb.gimp_image_get_layer_by_name(image,"Perspective Shadow")
	pdb.gimp_item_set_name(shadow,layer_name + " Perspective Shadow")
	#make a copy of fill layer
	fill_layer_copy = pdb.gimp_layer_new_from_drawable(fill_layer,image)
	pdb.gimp_image_insert_layer(image,fill_layer_copy,None,pdb.gimp_image_get_item_position(image,highlights_layer))
	pdb.gimp_layer_set_mode(fill_layer_copy,LAYER_MODE_BURN_LEGACY)
	pdb.gimp_item_set_name(fill_layer_copy,layer_name + " fill burn")
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_omg_brumby",                           
	"OMG brummy aka transparent glass(2 layers, one black and white)",
	"OMG brummy aka transparent glass(2 layers, one black and white)",
	"Tin Tran",
	"Tin Tran",
	"2017",
	"<Image>/Python-Fu/OMG brumby aka transparent glass...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_DRAWABLE, "bg_layer", "Background Layer:", None),
	(PF_FILE, "gem_file", "Select gemclear.png:", ""),
	],
	[],
	python_omg_brumby)

main()
