#!/usr/bin/env python

# r-sun.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
import os
def python_r_sun(image, layer, centerx,centery,radius,width) :
	#pdb.gimp_image_undo_group_start(image)
	#copy all layers to layers
	fib1 = 0;
	fib2 = 1;
	while (1==1):
		pdb.gimp_message(fib2)
		inner_sel_radius = radius + fib1*width/20.0
		outter_sel_radius = radius + fib1*width/20.0+width
		inner_width = inner_sel_radius*2
		outter_width = outter_sel_radius*2
		pdb.gimp_image_select_ellipse(image,CHANNEL_OP_REPLACE,centerx-outter_sel_radius,centery-outter_sel_radius,outter_width,outter_width)
		pdb.gimp_image_select_ellipse(image,CHANNEL_OP_SUBTRACT,centerx-inner_sel_radius,centery-inner_sel_radius,inner_width,inner_width)
		non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
		if non_empty == TRUE:
			pdb.gimp_edit_fill(layer,FILL_FOREGROUND)
		else:
			break;
		pdb.gimp_displays_flush()
		fib = fib2 * 1.05
		fib1 = fib2
		fib2 = fib

		# break

	

	#pdb.gimp_context_pop()
	#pdb.gimp_image_undo_group_end(image)
	#pdb.gimp_displays_flush()


register(
	"python_fu_r_sun_tt",
	"r-sun",
	"r-sun",
	"Tin Tran",
	"Tin Tran",
	"January 2020",
	"<Image>/Python-Fu/A R Sun...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	(PF_SPINNER, "centerx", "Center X:", 1400, (1, 5000, 50)),  # alias PF_ADJUSTMENT
	(PF_SPINNER, "centery", "Center Y:", 1400, (1, 5000, 50)),  # alias PF_ADJUSTMENT
	(PF_SPINNER, "radius", "Radius:", 500, (1, 5000, 50)),  # alias PF_ADJUSTMENT
	(PF_SPINNER, "width", "Line Width:", 3, (1, 50, 50)),  # alias PF_ADJUSTMENT
	],
	[],
	python_r_sun)

main()
