#!/usr/bin/env python

# Random Colorization 1
# Created by Tin Tran (http://bakon.ca/gimplearn)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import math
#import string
#import Image
from gimpfu import *
import random
#from array import array
def python_random_colorization(image, layer, colors):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	pdb.gimp_selection_none(image)
	
	#creates new image with copy of layer
	new_image = pdb.gimp_image_new(layer.width,layer.height,RGB)
	pdb.gimp_display_new(new_image)
	layer_copy = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,layer_copy,None,0)
	
	
	pdb.plug_in_gauss(new_image,layer_copy,5.0,5.0,1)
	pdb.gimp_convert_indexed(new_image,NO_DITHER,MAKE_PALETTE,colors,False,True,"Gimp Custom Palette Ignored")
	
	#get colors
	numbytes,colormap = pdb.gimp_image_get_colormap(new_image)
	numcolors = len(colormap)/3
	
	pdb.gimp_image_convert_rgb(new_image)
	
	#make a another copy to colorize
	original_copy = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,original_copy,None,0)
	
	for i in range(0,numcolors):
		pdb.gimp_image_select_color(new_image,CHANNEL_OP_REPLACE,layer_copy,colormap[i*3:i*3+3])
		pdb.gimp_colorize(original_copy,random.randrange(0,360),50,0)
	pdb.gimp_selection_none(new_image)	
	pdb.gimp_selection_none(image)

	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_random_colorization",                           
	"Random Colorization",
	"Random Colorization",
	"Tin Tran",
	"Tin Tran",
	"May 2017",
	"<Image>/Python-Fu/Random Colorization...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "colors", "# of Colors:", 15, (1, 50, 1)),
	#(PF_COLOR, "oldcolor",  "Replace Color:",  (43,198,255)),
	#(PF_COLOR, "newcolor",  "With New Color:",  (255,198,0)),
	#(PF_SPINNER, "x1", "x1:", 0, (0, 100, 0.5)),
	#(PF_SPINNER, "y1", "y1:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "x2", "x2:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "y2", "y2:", 0, (0, 100, 0.5)),
	#(PF_COLOR, "black",  "Black point color",  (0,0,0) PF_FILE, "infilename", "Temp Filepath", "/Default/Path"),
	#(PF_COLOR, "white",  "White point color",  (255,255,255) ),
	#(PF_COLOR, "gray",  "Gray point color",  (128,128,128) )
	#(PF_FILE, "infilename", "Temp Filepath", "/Default/Path")
	#(PF_DIRNAME, "source_directory", "Source Directory", "") for some reason, on my computer when i(Tin) use PF_DIRNAME the pythonw.exe would crash
	],
	[],
	python_random_colorization)

main()
