#!/usr/bin/env python

# random_layer_that_starts_with.py
# To be called by Custom_font scripts to get random versions of a letter
# to resolve a request by sweenyMark: https://gimplearn.net/viewtopic.php?f=18&t=2588
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
#import colorsys
import random
from gimpfu import *
def python_random_layer_that_starts_with(image, layer, letter) : #layer isn't used.
	valid_layers = []
	for layer in image.layers:
		if (layer.name == letter) or (layer.name.startswith(letter + " ")):
			valid_layers.append(layer)
	layer_index = random.randrange(len(valid_layers))
	return_layer = valid_layers[layer_index]
	return return_layer

register(
	"python_fu_random_layer_that_starts_with",
	"Random layer that starts with",
	"Random layer that starts with",
	"Tin Tran",
	"Tin Tran",
	"December 2019",
	"<Image>/Python-Fu/Random layer that starts with",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_STRING, "letter", "letter (layer names that start with):", "A"),
	#(PF_COLOR, "color", "Colorize color:", (100, 21, 40) ),
	#defaulting 1st time call to foreground color.
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	],
	[
	(PF_DRAWABLE, "layer", "Layer to be returned"),
	],
	python_random_layer_that_starts_with)

main()
