#!/usr/bin/env python
# coding=utf-8
# -*- encoding: utf-8 -*-
# sample-pixels-at-guides-intersection.py Rel 1
# Created by Tin Tran
# Comments directed to http://gimplearn.net
# Inspired to do something similar to this page: https://www.artbycedar.com/square-paintings-destroying-art/
# (but quite different since we'll be using colorize in GIMP and we'll be using indexed colors to get our reduced color look) from 
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import random
from gimpfu import *
import math
import random
from gimpfu import *

def python_sample_pixels_at_guides_intersection(image, layer):
	#pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	Xes = [];
	Yes = [];
	guideid = -1;
	while guideid != 0:
		if (guideid == -1):
			guideid = 0 #first invocation
		guideid = pdb.gimp_image_find_next_guide(image,guideid)
		if (guideid != 0): #there is a guide keep working away
			orientation = pdb.gimp_image_get_guide_orientation(image,guideid);
			position = pdb.gimp_image_get_guide_position(image,guideid);
			if orientation == ORIENTATION_HORIZONTAL:
				Yes.append(position);
			else:
				Xes.append(position);	
		
	Xes = sorted(Xes,key=lambda x:x)	
	Yes = sorted(Yes,key=lambda y:y)
	pdb.gimp_message(len(Xes));
	pdb.gimp_message(len(Yes));
	image_new = pdb.gimp_image_new(len(Xes),len(Yes),RGB)
	layer_new = pdb.gimp_layer_new(image_new,image_new.width,image_new.height,RGBA_IMAGE,"pixel from guides intersection",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image_new,layer_new,None,0)
	pdb.gimp_display_new(image_new)
	for y in range(0,len(Yes)):
		for x in range(0,len(Xes)):
			ix = Xes[x]; iy = Yes[y];
			num_channels,pixel = pdb.gimp_drawable_get_pixel(layer,ix,iy)
			pdb.gimp_drawable_set_pixel(layer_new,x,y,4,[pixel[0],pixel[1],pixel[2],255]);



	# if (pdb.gimp_drawable_has_alpha(layer) == FALSE): #add alpha so that we always have 4 bytes for color
	# 	pdb.gimp_layer_add_alpha(layer)
	pdb.gimp_selection_none(image)
	pdb.gimp_displays_flush()
	#pdb.gimp_context_pop()
	#pdb.gimp_image_undo_group_end(image)
	pdb.gimp_message("Complete!")
	#return

register(
	"python_fu_sample_pixels_at_guides_intersection_tt",
	"Colorize square art a single layered image",
	"Colorize square art a single layered image",
	"Tin Tran",
	"Tin Tran",
	"Aug 11 2022",
	"<Image>/Python-Fu/Sample Pixels With Guides...",             #Menu path
	"RGB*, GRAY*",
	[
	#(PF_SPINNER, "hor", "No. of Horizontal Squares:", 8, (3, 200, 1)),
	# (PF_SPINNER, "vert", "Vertical/Circular Strips (Enter 0 for proportional to Pie Strips at that point):", 10, (0, 1000, 1)),
	# (PF_TOGGLE, "rand",   "Randomize Cut Angles and Radiuses:", 0),
	# (PF_SPINNER, "everyN", "Weave Every n cells:", 3, (1,100, 1)),
	# (PF_TOGGLE, "rand2",   "Randomize n:", 1),
	# (PF_SPINNER, "odds", "Odds of Weaving (out of 1000 if Random n is YES):", 666, (10,1000, 1)),
	# (PF_TOGGLE, "randomizelayer",   "Randomize Layer instead of Alternating:", 0),
	# (PF_TOGGLE, "autocenter",   "Auto Center:", 1),
	# (PF_SPINNER, "centerX", "Center X (if NO to Auto Center):", 100, (0,8000, 1)),
	# (PF_SPINNER, "centerY", "Center Y (if NO to Auto Center):", 100, (0,8000, 1)),
	# (PF_TOGGLE, "morerandom",   "Randomize Cut Angles EVEN MORE:", 0),
	#(PF_SPINNER, "px_height", "Height of each tile image:", 100, (1, 1000, 50)),
	],
	[],
	python_sample_pixels_at_guides_intersection)

main()
