#!/usr/bin/env python

# Scrolling Logo Rel 4
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimplearn.com or http://gimp-forum.net or http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Allows for another cover layer.
# Rel 3: Allow 2nd layer (scrolling layer) to be wider than image width and height. Just line up left edges if moving left, line up right edges if moving right.
# Rel 4: for GIMP 2.10.X and faster execution. You can use 2 layers (one background and one foreground [to be animated]) or 3 layers (one background and one foreground [to be animated] and a cover layer on top)
import math
import string
#import Image
from gimpfu import *
from array import array
import sys
def python_scrolling_logo(image, layer, scrollx, scrolly) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#get bottom layer as background
	#cover_layer = image.layers[0]
	layer = image.layers[-2]
	background = image.layers[-1]
	
	if (scrollx != 0):
		startxfactor = -scrollx/abs(scrollx)
		xstep = abs((image.width+layer.width)/scrollx)
	else:
		startxfactor = 0
		xstep = 100000
	
	if (scrolly != 0):
		startyfactor = -scrolly/abs(scrolly)
		ystep = abs((image.height+layer.height)/scrolly)
	else:
		startyfactor = 0
		ystep = 100000
	
	steps = int(math.ceil(min(xstep,ystep)))
	
	
	
	for i in range(0,steps):
		'''
		#copy background first
		new_bg = pdb.gimp_layer_new_from_drawable(background,image)
		pdb.gimp_image_insert_layer(image,new_bg,None,0)
		#copy active layer
		new_layer = pdb.gimp_layer_new_from_drawable(layer,image)
		pdb.gimp_image_insert_layer(image,new_layer,None,0)
		#copy cover layer
		new_cover = pdb.gimp_layer_new_from_drawable(cover_layer,image)
		pdb.gimp_image_insert_layer(image,new_cover,None,0)
		
		
		#scroll it
		pdb.gimp_layer_translate(new_layer,(image.width * startxfactor)+(i*scrollx),(image.height * startyfactor)+(i*scrolly))
		'''

		#merge down to get result layer and layer to image size it
		'''result_layer = pdb.gimp_image_merge_down(image,new_cover,EXPAND_AS_NECESSARY)
		result_layer = pdb.gimp_image_merge_down(image,result_layer,EXPAND_AS_NECESSARY)
		'''
		pdb.gimp_layer_set_offsets(layer,(image.width * startxfactor)+(i*scrollx),(image.height * startyfactor)+(i*scrolly))
		result_layer = pdb.gimp_layer_new_from_visible(image,image,"visible")
		pdb.gimp_image_insert_layer(image,result_layer,None,0)
		pdb.gimp_layer_resize_to_image_size(result_layer)
		pdb.gimp_item_set_visible(result_layer,FALSE)
		
	for layer in image.layers:
		pdb.gimp_item_set_visible(layer,TRUE)	
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_scrolling_logo",                           
	"Creates scrolling logo of active layer for animation",
	"Creates scrolling logo of active layer for animation",
	"Tin Tran",
	"Tin Tran",
	"2017",
	"<Image>/Python-Fu/Scrolling Logo...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "scrollx", "Scroll x:", 10, (-500, 500, 1)),
	(PF_SPINNER, "scrolly", "Scroll y:", 0, (-500, 500, 1)),
	],
	[],
	python_scrolling_logo)

main()
