#!/usr/bin/env python

# Sport Jersey Flags Rel 1
# Created by Tin Tran (https://gimplearn.net)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.

#import math
#import string
#import Image
from gimpfu import *
#from array import array

def python_sport_jersey_flags(image, layer, name,number,namefont,numberfont,jerseycolor,teamcolor1,teamcolor2):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	img = pdb.gimp_image_new(1000,1000,RGB)
	pdb.gimp_display_new(img)
	
	#======== main jersey flag ============================================
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"main jersey",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,284,49,432,902)
	pdb.gimp_context_set_foreground(jerseycolor)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"main color1",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,284,802,432,149)
	pdb.gimp_context_set_foreground(teamcolor1)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,284,49,432,29)
	pdb.gimp_context_set_foreground(teamcolor1)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"main color2",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,284,696,432,71)
	pdb.gimp_context_set_foreground(teamcolor2)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	#creates number layer
	textlayer = pdb.gimp_text_fontname(img,None,0,0,number,0,True,350,0,numberfont)
	pdb.plug_in_autocrop_layer(img,textlayer)
	scale = 298.0/textlayer.height
	width = textlayer.width * scale
	width = min(316.0,width)
	pdb.gimp_layer_scale(textlayer,width,298,False)
	pdb.gimp_layer_set_offsets(textlayer,500-textlayer.width/2,469-textlayer.height/2)
	
	pdb.gimp_image_select_item(img,CHANNEL_OP_REPLACE,textlayer)
	pdb.gimp_selection_shrink(img,8)
	pdb.gimp_context_set_foreground(teamcolor1)
	pdb.gimp_edit_fill(textlayer,FOREGROUND_FILL)
	pdb.gimp_layer_resize_to_image_size(textlayer)
	
	#creates name layer
	textlayer = pdb.gimp_text_fontname(img,None,0,0,name.upper(),0,True,350,0,namefont)
	pdb.plug_in_autocrop_layer(img,textlayer)
	scale = 72.0/textlayer.height
	width = textlayer.width * scale
	width = min(316.0,width)
	pdb.gimp_layer_scale(textlayer,width,72.0,False)
	pdb.gimp_layer_set_offsets(textlayer,500-textlayer.width/2,245-textlayer.height/2)
	pdb.gimp_layer_resize_to_image_size(textlayer)
	
	#======= arm flag =====================================
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"arm jersey",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,753,117,218,721)
	pdb.gimp_context_set_foreground(jerseycolor)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"arm color1",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,753,235,218,272)
	pdb.gimp_context_set_foreground(teamcolor1)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,753,592,218,46)
	pdb.gimp_context_set_foreground(teamcolor1)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	layer = pdb.gimp_layer_new(img,1000,1000,RGBA_IMAGE,"arm color2",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(img,layer,None,0)
	pdb.gimp_image_select_rectangle(img,CHANNEL_OP_REPLACE,753,550,218,42)
	pdb.gimp_context_set_foreground(teamcolor2)
	pdb.gimp_edit_fill(layer,FOREGROUND_FILL)
	
	#creates number layer
	textlayer = pdb.gimp_text_fontname(img,None,0,0,number,0,True,350,0,numberfont)
	pdb.plug_in_autocrop_layer(img,textlayer)
	scale = 120.0/textlayer.height
	width = textlayer.width * scale
	width = min(122.0,width)
	pdb.gimp_layer_scale(textlayer,width,120.0,False)
	pdb.gimp_layer_set_offsets(textlayer,862-textlayer.width/2,384-textlayer.height/2)
	
	pdb.gimp_image_select_item(img,CHANNEL_OP_REPLACE,textlayer)
	pdb.gimp_selection_shrink(img,4)
	pdb.gimp_context_set_foreground(jerseycolor)
	pdb.gimp_edit_fill(textlayer,FOREGROUND_FILL)
	pdb.gimp_layer_resize_to_image_size(textlayer)
	
	
	pdb.gimp_selection_none(img)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_sport_jersey_flags",                           
	"Creates Sport Jersey Flags",
	"Creates Sport Jersey Flags",
	"Tin Tran",
	"Tin Tran",
	"June 2017",
	"<Image>/Python-Fu/Sport Jersey Flags...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_STRING, "name", "Player Name:", "Crossby"),
	(PF_STRING, "number", "Player Number:", "87"),
	(PF_FONT, "namefont", "Player Name Font:", "Sans Bold"),
	(PF_FONT, "numberfont", "Player Number Font:", "Sans Bold"),
	(PF_COLOR, "jerseycolor",  "Jersey Color:",  (22,22,22)),
	(PF_COLOR, "teamcolor1",  "Team Color 1(Name color):",  (240,188,66)),
	(PF_COLOR, "teamcolor2",  "Team Color 2(Number outline):",  (240,240,240)),
	],
	[],
	python_sport_jersey_flags)

main()
