#!/usr/bin/env python

# stickerify.py Release 1
# Created by Tin Tran http://gimplearn.net
# This plug-in was requested by Mackenzieh here: https://www.gimplearn.net/viewtopic.php/Sticker-Script-Request?p=23408#p23408
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
from gimpfu import *
import random
#from array import array
#import sys

def python_tt_stickerify(image, layer, grow, blurx, blury, movex, movey, merge):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#core code goes here/below
	
	pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,layer)
	active_layer_position = pdb.gimp_image_get_item_position(image,layer)
	#creates white grow layer
	white_layer = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"White Grow",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image,white_layer,None,active_layer_position+1)
	pdb.gimp_selection_grow(image,grow)
	pdb.gimp_context_set_foreground((255,255,255))
	pdb.gimp_edit_fill(white_layer,FILL_FOREGROUND)
	#creates shadow layer
	shadow_layer = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Shadow",80,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(image,shadow_layer,None,active_layer_position+2)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(shadow_layer,FILL_FOREGROUND)
	pdb.gimp_selection_none(image)
	pdb.plug_in_gauss(image,shadow_layer,blurx,blury,1)
	pdb.gimp_layer_translate(shadow_layer,movex,movey)
	pdb.gimp_layer_resize_to_image_size(shadow_layer)
	#merge layers
	if merge == 1:
		merged_layer = pdb.gimp_image_merge_down(image,layer,EXPAND_AS_NECESSARY)
		merged_layer = pdb.gimp_image_merge_down(image,merged_layer,EXPAND_AS_NECESSARY)


	#UNCOMMENT BELOW WHEN DONE
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_tt_stickerify",                           
	"Creates Sticker effect out of layer with transparency",
	"Creates Sticker effect out of layer with transparency",
	"Tin Tran",
	"Tin Tran",
	"Feb 2019",
	"<Image>/Python-Fu/Stickerify..",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "grow", "White Grow By (pixels):", 40, (2, 1000, 1)),
	(PF_SPINNER, "blurx", "Shadow Gausian Blur X Radius (pixels):", 15, (2, 1000, 1)),
	(PF_SPINNER, "blury", "Shadow Gausian Blur Y Radius (pixels):", 15, (2, 1000, 1)),
	(PF_SPINNER, "movex", "Shadow Translate X (pixels):", 5, (-1000, 1000, 1)),
	(PF_SPINNER, "movey", "Shadow Translate Y (pixels):", 3, (-1000, 1000, 1)),
	(PF_TOGGLE,  "merge",   "Merge Layers:", 0), 
	#(PF_SPINNER, "xjitter", "X Jitter (pixels):", 50, (1, 2000, 1)),
	#(PF_SPINNER, "yjitter", "Y Jitter (pixels):", 50, (1, 2000, 1)),	
	],
	[],
	python_tt_stickerify)

main()
