#!/usr/bin/env python

# tile-puzzle.py
# Created by Tin Tran
# Comments directed to http://gimplearn.net or http://gimp-forum.net or http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import random
#import Image
from gimpfu import *


def python_tilepuzzle(image, layer, xtiles, ytiles, rotate, flip):
	#pdb.gimp_image_undo_group_start(image)
	#pdb.gimp_context_push()
	xtiles = int(xtiles);
	ytiles = int(ytiles);
	width = xtiles * layer.width;
	height = ytiles * layer.height;
	newimage = pdb.gimp_image_new(width,height,RGB);
	pdb.gimp_display_new(newimage);
	worklayer = pdb.gimp_layer_new(newimage,width,height,RGBA_IMAGE,"tile puzzle",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(newimage,worklayer,None,0)
	tiles = len(image.layers)
	rotate = int(rotate);
	flip = int(flip);
	for y in range(0,ytiles):
		for x in range(0,xtiles):
			i = random.randrange(0,tiles)
			picklayer = image.layers[i]
			layercopy = pdb.gimp_layer_new_from_drawable(picklayer,newimage)
			pdb.gimp_image_insert_layer(newimage,layercopy,None,0)
			if (rotate == 1):
				r = random.randrange(0,4);
				if r < 3:
					pdb.gimp_item_transform_rotate_simple(layercopy,r,TRUE,0,0)
			if (flip == 1):
				r = random.randrange(0,2);
				if r > 0:
					pdb.gimp_item_transform_flip_simple(layercopy,0,TRUE,0)		
			worklayer = pdb.gimp_layer_set_offsets(layercopy,x*layer.width,y*layer.height)
			pdb.gimp_image_merge_down(newimage,layercopy,CLIP_TO_BOTTOM_LAYER)

	#pdb.gimp_context_pop()
	#pdb.gimp_image_undo_group_end(image)
	#pdb.gimp_displays_flush()
    #return
register(
	"python_fu_tilepuzzle",                           
	"Get Data for Treemap",
	"Get Data for Treemap",
	"Tin Tran",
	"Tin Tran",
	"Jan 1,2023",
	"<Image>/Python-Fu/A Tile Puzzle",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "xtiles", "X-tiles:", 16, (5,500, 1)),
	(PF_SPINNER, "ytiles", "Y-tiles:", 16, (5,500, 1)),
	(PF_TOGGLE, "rotate", "Randomly rotate tiles:", 0),
	(PF_TOGGLE, "flip", "Randomly flip tiles:", 0),
	],
	[],
	python_tilepuzzle)

main()
