#!/usr/bin/env python

# top_layer_on_all_layers Rel 1
# Created by Tin Tran
# Comments directed to http://gimplearn.net
# This script will put the top layer on all other layers and merge down.
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
from gimpfu import *
# try:
# 	#Try to set a variable to pdb, if it works then we're inside GIMP execution
# 	test = pdb
# except:
# 	#If it fails we're on our own so we'll use this for autocomplete
# 	try:
# 		import mypdb as pdb #import this file so that we bet pdb.* autocomplete
# 		from myenums import * #import this file so that we have ENUMS autocomplete
# 	except:
# 		pass

def python_top_layer_on_all_layers_tt(image, layer):
	pdb.gimp_image_undo_group_start(image)
	#pdb.gimp_context_push()
	top_layer = image.layers[0] #top layer

	rest_of_layers = list(image.layers[1:]) #all other layers except layer 0

	for i in range(0,len(rest_of_layers)):
		cur_layer = rest_of_layers[i]
		position = pdb.gimp_image_get_item_position(image, cur_layer) #grabs position
		copy = pdb.gimp_layer_new_from_drawable(top_layer, image) #copy of top layer
		pdb.gimp_image_insert_layer(image, copy, None, position)  #insert into position so that it's on top of existing
		result_layer = pdb.gimp_image_merge_down(image, copy, EXPAND_AS_NECESSARY) #merge down


	#pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_top_layer_on_all_layers_tt",
	"Puts copies of top layer over other layers and merge down",
	"Puts copies of top layer over other layers and merge down",
	"Tin Tran",
	"Tin Tran",
	"October 2018",
	"<Image>/Python-Fu/Top Layer on All Layers",             #Menu path
	"RGB*, GRAY*",
	[
	],
	[],
	python_top_layer_on_all_layers_tt)

main()
