#!/usr/bin/env python

# wobble3d.py
# Created by Tin Tran
# 
# Comments directed to http://gimplearn.net or http://gimp-forum.net or http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Random Variable
# Rel 3: Should be slightly faster
# Rel 4: Optimized
# Rel 5: Fixed Bug introduced since version 3 from optimization
# Rel 6: Super optimized, what previously took over an hour now takes 94 seconds
# Rel 7: Ignore invalid points bug fix as sometimes it bugs out and gives points in the top left corner
import math
import random
#import Image
from gimpfu import *
import time
import inspect

# define a class
class Point:
	x = 50
	y = 0
	z = 0

#create object Point
point = Point();
#//below code found at:https://stackoverflow.com/a/34060479/2948749 but translated into Python here
# def rotate(pitch, roll, yaw):
# 	global point

# 	cosa = math.cos(yaw);
# 	sina = math.sin(yaw);

# 	cosb = math.cos(pitch);
# 	sinb = math.sin(pitch);

# 	cosc = math.cos(roll);
# 	sinc = math.sin(roll);

# 	Axx = cosa*cosb;
# 	Axy = cosa*sinb*sinc - sina*cosc;
# 	Axz = cosa*sinb*cosc + sina*sinc;

# 	Ayx = sina*cosb;
# 	Ayy = sina*sinb*sinc + cosa*cosc;
# 	Ayz = sina*sinb*cosc - cosa*sinc;

# 	Azx = -sinb;
# 	Azy = cosb*sinc;
# 	Azz = cosb*cosc;

#     #for (var i = 0; i < points.length; i++) { we're just doing the one point in this case
# 	px = point.x;
# 	py = point.y;
# 	pz = point.z;

# 	point.x = Axx*px + Axy*py + Axz*pz;
# 	point.y = Ayx*px + Ayy*py + Ayz*pz;
# 	point.z = Azx*px + Azy*py + Azz*pz;
#// code above found, (translation) ends here -----------------

#define cos & sin constants see if it's faster
def rad(a): #//radian
	return math.radians(a);
cosconst = [] 
sinconst = []
#precompute all 360 degrees for cos and sin
for a in range(0,360):
	cosconst.append(math.cos(math.radians(a)));
	sinconst.append(math.sin(math.radians(a)));
#cos takes angle in degrees


class mydot: #Not sure if we need this here as we'll be getting our points from path
	x = 500
	y = 500
	
inca = 4.7; #//increment angle
#incr = rad(inca);
incr = inca;
halfincr = 0.5*incr;
quartincr = 0.25*incr;


def python_wobble3d(image, layer,wobblefactor,pathspeed,maxspeed):
	#pdb.gimp_image_undo_group_start(image)
	#pdb.gimp_context_push()
	st = time.time()
	active_vectors = pdb.gimp_image_get_active_vectors(image)
	num_strokes,stroke_ids = pdb.gimp_vectors_get_strokes(active_vectors)
	precision = 0.1
	new_vectors = pdb.gimp_vectors_new(image,"3D wobble hand-scribble")
	temp_vectors = pdb.gimp_vectors_new(image,"Temp vectors for speed")
	#anal speed up variables to call
	_random = random.random
	_remove_stroke = temp_vectors.remove_stroke
	_gimpStroke = gimp.VectorsBezierStroke
	_int = int
	times = [0]*10;
	fullcircle = math.pi*2
	pitch = _random()*fullcircle;
	roll = _random()*fullcircle;
	yaw = _random()*fullcircle;
	_abs = abs
	gimpVectorsBezierStroke = gimp.VectorsBezierStroke
	pdbgimp_progress_update = pdb.gimp_progress_update
	pdbgimp_progress_set_text = pdb.gimp_progress_set_text
	
	cs = 0 #current stroke counter
	updateEveryTimes6 = 6 * 1200
	pdbgimp_progress_update(0)
	_len = len
	strstrokecount = str(_len(active_vectors.strokes))
	timetime = time.time
	lastUpdateTime = timetime()
	for sourceStroke in active_vectors.strokes:
		
		cs += 1
		slength = sourceStroke.get_length(precision)
		spoints,sclosed=sourceStroke.points
		
		dist = 0;
		index = 0;
		speedrange = (maxspeed-pathspeed);
		lastdist = -1;
		ox = -1;
		oy = -1;
		start = 0 #start at 0 and count
		spoints_count = _len(spoints)/6
		
		dists = [] #all single dists will store in here
		endtotaldist = []
		distuptonow = 0
		shortStrokeIds = []
		#just get the first Short Stroke 
		ci = 0;	
		faststroke = gimpVectorsBezierStroke(temp_vectors,spoints[start:start+12],0)
		new_stroke_id = faststroke.ID

		shortStrokeIds.append(new_stroke_id) #save for deletion later
		start += 6
		this_dist = temp_vectors.strokes[0].get_length(precision)
		_distappend = dists.append
		_distappend(this_dist)
		distuptonow += this_dist
		_endtotaldistappend = endtotaldist.append
		_endtotaldistappend(distuptonow)
		ci +=1

		
		currentStrokeIndex = 0
		currentShortStroke = faststroke
		_get_point_at_dist = currentShortStroke.get_point_at_dist
		thisstrokedist = 0
		strokepoints = []
		_strokepointsextend = strokepoints.extend
		pdbgimp_progress_update(dist/slength)
		while dist < slength:
			pitch += _random()*halfincr-quartincr;
			if pitch < -incr:
				pitch = -incr
			elif pitch > incr:
				pitch = incr
			#pitch = max(-incr,min(incr,pitch));
			roll += _random()*halfincr-quartincr;
			if roll < -incr:
				roll = -incr
			elif roll > incr:
				roll = incr
			#roll = max(-incr,min(incr,roll));
			yaw += _random()*halfincr-quartincr;
			if yaw < -incr:
				yaw = -incr
			elif yaw > incr:
				yaw = incr
			#yaw = max(-incr,min(incr,yaw));
			intyaw = _int(yaw) #%360
			cosa = cosconst[intyaw]
			sina = sinconst[intyaw]
			intpitch = _int(pitch) #%360
			cosb = cosconst[intpitch]
			sinb = sinconst[intpitch]
			introll = _int(roll) #%360
			cosc = cosconst[introll]
			sinc = sinconst[introll]

			Axx = cosa*cosb;
			Axy = cosa*sinb*sinc - sina*cosc;
			Axz = cosa*sinb*cosc + sina*sinc;
			Ayx = sina*cosb;
			Ayy = sina*sinb*sinc + cosa*cosc;
			Ayz = sina*sinb*cosc - cosa*sinc;
			Azx = -sinb;
			Azy = cosb*sinc;
			Azz = cosb*cosc;
			px = point.x;
			py = point.y;
			pz = point.z;
			point.x = Axx*px + Axy*py + Axz*pz;
			point.y = Ayx*px + Ayy*py + Ayz*pz;
			point.z = Azx*px + Azy*py + Azz*pz;
			distdiff = dist-lastdist
			#don't need to get points if it's within 1 pixel, just let it use the previous sx,sy
			if (distdiff > 0.999):
				while (dist > endtotaldist[currentStrokeIndex]):
					if ci < spoints_count-1:
						_remove_stroke(faststroke)
						faststroke = _gimpStroke(temp_vectors,spoints[start:start+12],0)
						new_stroke_id = faststroke.ID
						shortStrokeIds.append(new_stroke_id) #save for deletion later
						start += 6
						this_dist = faststroke.get_length(precision)
						_distappend(this_dist)
						distuptonow += this_dist
						_endtotaldistappend(distuptonow)
						ci += 1
					elif ci == spoints_count-1 and sclosed==1:
						_remove_stroke(faststroke)
						faststroke = _gimpStroke(temp_vectors,spoints[start:start+6]+spoints[0:6],0)
						new_stroke_id = faststroke.ID
						shortStrokeIds.append(new_stroke_id) #save for deletion later
						start += 6
						this_dist = faststroke.get_length(precision)
						_distappend(this_dist)
						distuptonow += this_dist
						_endtotaldistappend(distuptonow)
						ci += 1

					currentStrokeIndex+=1 #move to next stroke
					currentShortStroke = faststroke
					_get_point_at_dist = currentShortStroke.get_point_at_dist
					thisstrokedist = dists[currentStrokeIndex]-(endtotaldist[currentStrokeIndex]-dist)
				sx,sy,slope,valid = _get_point_at_dist(thisstrokedist,precision)
				lastdist = dist
			x = sx + point.x*wobblefactor;
			y = sy + point.y*wobblefactor;
			if ((_abs(x-ox) > 0.99 or _abs(y-oy) > 0.99) and valid == TRUE):
				ox = x
				oy = y
				_strokepointsextend([x,y]*3)
				index += 6;
				currentTime = timetime()
				if (currentTime - lastUpdateTime > 0.5): #updates every 1/2 second
					lastUpdateTime = currentTime
					pdbgimp_progress_update(dist/slength)
					pdbgimp_progress_set_text(str(cs) + "/" + strstrokecount + " strokes...")
			dist_inc = _random()*speedrange+pathspeed;
			dist += dist_inc
			thisstrokedist += dist_inc #increment as wel with same amount
		if temp_vectors.strokes:
			_remove_stroke(faststroke)
		pdbgimp_progress_update(dist/slength)
		new_stroke = _gimpStroke(new_vectors,strokepoints,sclosed)
	pdb.gimp_image_insert_vectors(image,new_vectors,None,0)
	et = time.time()
	times[0]+=et-st
		#pdb.gimp_vectors_remove_stroke(temp_vectors,new_stroke_id)
	#End by removing temp vectors
	#pdb.gimp_image_remove_vectors(image,temp_vectors)
	pdb.gimp_message("Time taken: "+str(int(times[0]*100)/100.0)+" seconds")
		#return strokepoints[0:index];
		#CODE CALL ABOV instead of function since function calls can be expensive =============================================		
		
		#new_stroke_id = pdb.gimp_vectors_stroke_new_from_points(new_vectors,0,len(new_stroke_points),new_stroke_points,sclosed)
	#pdb.gimp_context_pop()
	#pdb.gimp_image_undo_group_end(image)
	#pdb.gimp_displays_flush()
    #return
register(
	"python_fu_wobble3d",
	"Wobble 3D AKA hand-scribble a path",
	"Wobble 3D AKA hand-scribble a path",
	"Tin Tran",
	"Tin Tran",
	"Jan 16,2023",
	"<Image>/Python-Fu/A Wobble3D hand-scribble",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "wobblefactor", "Wobble-factor:", 0.1, (0,50, 0.001)),
	(PF_SPINNER, "pathspeed", "Minimum Path-speed:", 1.0, (0.01,100, 0.01)),
	(PF_SPINNER, "maxpathspeed", "Maximum Path-speed:", 1.0, (0.01,100, 0.01)),
	# (PF_TOGGLE, "rotate", "Randomly rotate tiles:", 0),
	# (PF_TOGGLE, "flip", "Randomly flip tiles:", 0),
	],
	[],
	python_wobble3d)

main()
